2011-02-17  Ed Leafe <ed@leafe.com>

	Added support for feature parity with the current Rackspace Cloud Servers practice of "injecting" files into newly-created instances for configuration, etc. However, this is in no way restricted to only writing files to the guest when it is first created.

2011-02-17  Soren Hansen <soren.hansen@rackspace.com>

	Add **kwargs to VlanManager's create_networks so that optional args from other managers don't break.

2011-02-17  Sandy Walsh <sandy.walsh@rackspace.com>

	Added http://mynova/v1.0/zones/ api options for add/remove/update/delete zones. child_zones table added to database and migration. Changed novarc vars from CLOUD_SERVERS_* to NOVA_* to work with novatools. See python-novatools on github for help testing this. 

2011-02-17  Soren Hansen <soren.hansen@rackspace.com>

	Make eth0 the default for the public_interface flag.

2011-02-17  Soren Hansen <soren.hansen@rackspace.com>

	Re-alphabetise Authors, move extra addresses into .mailmap.

2011-02-17  Ricardo Carrillo Cruz <emaildericky@gmail.com>

	Hi guys
	
	Taking Jay suggestion, i completely got rid of BadParameter and just used ValueError, no point of using a new exception class when there's already something available in Python for that purpose.
	
	Regards

2011-02-17  Brian Waldon <brian.waldon@rackspace.com>

	Update the Openstack API so that it returns 'addresses'.
	
	This branch should resolve nova bug #713144 (https://bugs.launchpad.net/nova/+bug/713144).

2011-02-17  Brian Lamar <brian.lamar@rackspace.com>, brian-lamar <brian.lamar@rackspace.com>

	I have a bug fix, additional tests for the `limiter` method, and additional commenting for a couple classes in the OpenStack API. Basically I've just tried to jump in somewhere to get my feet wet. Constructive criticism welcome.

2011-02-17  Trey Morris <trey.morris@rackspace.com>

	added labels to networks for use in multi-nic
	added writing network data to xenstore param-list
	added call to agent to reset network
	added reset_network call to openstack api

2011-02-17  Christian Berendt <berendt@b1-systems.de>

	Add a command to nova-manage to list fixed ip's.

2011-02-17  Christian Berendt <berendt@b1-systems.de>

	example:
	
	# nova-manage network list
	CIDR                    netmask         dhcp_start      DNS            
	xx.xx.35.0/25           255.255.255.128 xx.xx.35.2      None           
	xx.xx.36.0/25           255.255.255.128 xx.xx.36.2      None
	
	(DNS set to None because networks not yet used..)

2011-02-17  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes ldapdriver so that it works properly with admin client.  It now sanitizes all unicode data to strings before passing it into ldap driver.  This may need to be rethought to work properly for internationalization.

2011-02-16  termie <code@term.ie>

	Update to our HACKING doc to add examples of our docstring style.

2011-02-16  Brian Schott <bschott@isi.edu>, Brian Schott <bschott@isi.edu>

	-from migrate.versioning import exceptions as versioning_exceptions
	+
	+try:
	+    from migrate.versioning import exceptions as versioning_exceptions
	+except ImportError:
	+    try:
	+        # python-migration changed location of exceptions after 1.6.3
	+        # See LP Bug #717467
	+        from migrate import exceptions as versioning_exceptions
	+    except ImportError:
	+        sys.exit(_("python-migrate is not installed. Exiting."))

2011-02-16  Soren Hansen <soren.hansen@rackspace.com>

	Use RotatingFileHandler instead of FileHandler.

2011-02-16  Soren Hansen <soren.hansen@rackspace.com>

	Use a threadpool for handling requests coming in through RPC.

2011-02-16  Anthony Young <sleepsonthefloor@gmail.com>

	Fix for bug #716847
	
	If a volume has not yet been assigned to a host, then have "nova-manage volume delete" delete from database and skip the rpc.

2011-02-16  Soren Hansen <soren.hansen@rackspace.com>

	Add back --logdir=DIR option. If set, a logfile named after the binary (e.g. nova-api.log) will be kept in DIR.

2011-02-16  Vasiliy Shlykov <vash@vasiliyshlykov.org>

	This branch should resolve nova bug #718675 (https://bugs.launchpad.net/nova/+bug/718675).
	
	Also added dropping of tables in case of failures so `nova-manage sync db` will can restart next time.

2011-02-15  Trey Morris <trey.morris@rackspace.com>

	this bug bit me hard today. pv can be None, which does not translate to %d and this error gets clobbered by causing errors in the business in charge of capturing output and reporting errors.

2011-02-15  Thierry Carrez <thierry@openstack.org>

	Fixes tarball contents by adding missing scripts and files to setup.py / MANIFEST.in

2011-02-15  Justin Santa Barbara <justin@fathomdb.com>

	When re-throwing an exception, use "raise", not "raise e".  This way we don't lose the stack trace.

2011-02-15  Salvatore Orlando <salvatore.orlando@eu.citrix.com>

	The proposed fix puts a VM which fails to spawn in a (new) 'FAILED' power state. It does not perform a clean-up.
	This because the user needs to know what has happened to the VM he/she was trying to run. Normally, API users do not have access to log files. In this case, the only way for the user to know what happened to the instance is to query its state (e.g.: doing euca-describe-instances). If we perform a complete clean-up, no information about the instance which failed to spawn will be left.
	
	For the NO_HOST_AVAILABLE error, which occurs when there is not enough RAM left on the host, the amount of available memory is now checked at the beginning of the spawn process. This way, if there is not enough RAM left on the host, the spawn process returns immediately.
	A test case (spawn_not_enough_memory) has been added as well.
	
	I understand adding a new value to the power_state enumeration might not be acceptable. In that case I will propose for merge a different branch in which we perform a complete clean-up.
	However, I reckon we still to provide a way to inform the user the spawn process has failed.

2011-02-15  termie <code@term.ie>

	Some trivial cleanups in context.py, mostly just a test of using the updated git-bzr-ng

2011-02-15  Soren Hansen <soren.hansen@rackspace.com>

	Use eventlet.green.subprocess instead of standard subprocess

2011-02-15  Soren Hansen <soren.hansen@rackspace.com>

	Fix sporadically failing unittests.

2011-02-15  Dan Prince <dan.prince@rackspace.com>

	Fixes issues when running euca-run-instances and euca-describe-image-attribute against the latest nova/trunk EC2 API.
	
	I noticed this late this afternoon and saw some IRC traffic with other users hitting the issue as well.

2011-02-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds missing flag that makes use_nova_chains work properly.

2011-02-14  Salvatore Orlando <salvatore.orlando@eu.citrix.com>

	Made kernel and ram disk be deleted in xen api upon instance termination 
	

2011-02-14  Devin Carlen <devin.carlen@gmail.com>

	Modified S3ImageService to return the format defined in BaseService to allow EC2 API's DescribeImages to work against Glance.

2011-02-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes a typo in the auth checking for DescribeAvailabilityZones.

2011-02-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes describe_security_groups by forcing it to return a list instead of a generator.

2011-02-13  Ricardo Carrillo Cruz <emaildericky@gmail.com>

	Hi guys
	
	This branch fixes lp708329.
	
	Have a look at cloud.py/describe_security_groups , it was just a matter of sorting by project, then by group name before returning the groups.
	
	Regards

2011-02-11  Vishvananda Ishaya <vishvananda@gmail.com>

	This fixes a lazy-load issue in describe-instances, which causes a crash.  The solution is to specifically load the network table when retrieving an instance.

2011-02-11  Soren Hansen <soren.hansen@rackspace.com>

	Create a new AMQP connection by default.

2011-02-10  Rick Harris <rconradharris@gmail.com>

	Define sql_idle_timeout flag to be an integer.
	
	This fixes bug706405 where MySQL Gone Away Errors were being generated.

2011-02-10  Soren Hansen <soren.hansen@rackspace.com>

	Add forwarding rules for floating IPs to the OUTPUT chain on the network node in addition to the PREROUTING chain.

2011-02-10  Soren Hansen <soren.hansen@rackspace.com>

	Use a NullPool for sqlite connections.

2011-02-10  Soren Hansen <soren.hansen@rackspace.com>

	Get a fresh connection in rpc.cast rather than using a recycled one.

2011-02-10  Bilal Akhtar <bilalakhtar@ubuntu.com>

	This branch fixes bug #708347: RunInstances: Invalid instance type gives improper error message

2011-02-09  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes the ordering of init_host commands so that iptables chains are created before they are used.
	
	This fixes an issue that arises if nova-network is started with flushed iptables after floating ips have been assigned.

2011-02-09  Soren Hansen <soren.hansen@rackspace.com>

	Pass timestamps to the db layer in fixed_ip_disassociate_all_by_timeout rather than converting to strings ahead of time, otherwise comparison between timestamps would often fail.

2011-02-09  SuperStack <justin@fathomdb.com>, Justin Santa Barbara <justin@fathomdb.com>

	Added support for 'SAN' style volumes.  A SAN's big difference is that the iSCSI target won't normally run on the same host as the volume service.

2011-02-08  Vishvananda Ishaya <vishvananda@gmail.com>

	Automates the setup for FlatDHCP regardless of whether the interface has an ip address.
	
	FlatDHCP only has worked until now if the underlying interface that you bridge into has no ip address.  This branch will do the necessary setup to allow it to work by:
	
	* Creating a bridge with the private address for dhcp
	* Moving any existing ips from the interface onto the bridge
	* Adding the interface to the bridge
	* Recreating the default route if it was deleted by moving the interface
	
	It will additionally add a route to compute hosts for bridges that it adds to the compute hosts.  This seems to be necessary in some cases where the default route uses a different interface.

2011-02-08  Christian Berendt <berendt@b1-systems.de>

	fixes #713766 and probably #710959, please test the patch before committing it.

2011-02-08  Anne Gentle <anne@openstack.org>

	Updates to the multinode install doc based on Wayne's findings. Merged with trunk so should easily merge in.

2011-02-08  Ryan Lane <rlane@wikimedia.org

	Checks whether the instance id is a list or not before assignment. This is to fix a bug relating to nova/boto. The AWK-SDK libraries pass in a string, not a list. The euca tools pass in a list.

2011-02-08  Ryan Lane <rlane@wikimedia.org

	Catching all socket errors in _get_my_ip, since any socket error is likely enough to cause a failure in detection.

2011-02-07  Christian Berendt <berendt@b1-systems.de>

	added new parameter --dhcp_domain to set the used domain by dnsmasq in /etc/nova/nova.conf

2011-02-04  Ricardo Carrillo Cruz <emaildericky@gmail.com>

	Fixes https://bugs.launchpad.net/nova/+bug/681417 

2011-02-04  termie <code@term.ie>

	Adds logging.basicConfig() to run_tests.py so that attempting to log debug messages from tests will work.

2011-02-03  termie <code@term.ie>

	Changes the behavior of run_test.sh so that pep8 is only run in the default case (when running all tests). It will no longer run when individual test cases are being given as in:
	
	./run_tests.sh nova.tests.test_compute

2011-02-03  Soren Hansen <soren.hansen@rackspace.com>

	open cactus

2011-02-02  Soren Hansen <soren.hansen@rackspace.com>

	Set FINAL = True in version.py.

2011-02-01  Anthony Young <sleepsonthefloor@gmail.com>

	Fixes bug #709057
	
	* Mark security_group_instance_associations as deleted when instance deleted
	* Mark security_group_instance_associations as deleted when security_group deleted
	* Make SecurityGroup.instances mapping properly ignore deleted security_group_instance_associations
	* Add tests
	
	IMO, this is important to merge.  Nebula has monitoring projects that continually launch and destroy instances, and I imagine other real-world deployments may have similar health checkers.  After a few weeks such health checkers choke due to the inefficient queries related to #709057.

2011-02-01  Tushar Patil <tushar.vitthal.patil@gmail.com>

	Fix for LP Bug #709510

2011-02-01  Ilya Alekseyev <ialekseev@griddynamics.com>

	Changed default handler for uncaughted exceptions. It uses logging instead print to stderr.

2011-01-31  Devin Carlen <devin.carlen@gmail.com>

	Enabled modification of projects using the EC2 admin API.

2011-01-31  termie <code@term.ie>

	Match the initial db version to the actual Austin release db schema.
	
	Fixes: https://bugs.launchpad.net/nova/+bug/709183
	
	Tested by copying nova/tests/db/nova.austin.sqlite to ./nova.sqlite and running ./bin/nova-manage db sync

2011-01-30  Devin Carlen <devin.carlen@gmail.com>

	Made adminclient get_user return None instead of throwing EC2Exception if requested user not available.
	
	This change is isolated to the adminclient code itself and has no ramifications on the nova server codebase. 
	
	This bug severely impacts automated deployments of django-nova and the openstack-dashboard, which are scheduled for formal release next week, so I'd really like to see this simple patch make it in for bexar release.

2011-01-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Disassociate all floating ips on terminate instance.

2011-01-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes simple scheduler to able to be run_instance by admins + availability zones.

2011-01-28  Monty Taylor <mordred@inaugust.com>

	Makes having sphinx to build docs a conditional thing - if you have it, you can get docs. If you don't, you can't.

2011-01-28  Ryan Lane <rlane@wikimedia.org

	Adds security group output to describe_instances.

2011-01-28  Todd Willey <todd@ansolabs.com>

	Use firewall_driver flag as expected with NWFilterFirewall.  This way, either you use NWFilterFirewall directly, or you use IptablesFirewall, which creates its own instance of NWFilterFirewall for the setup_basic_filtering command.  This removes the requirement that LibvirtConnection would always need to know about NWFirewallFilter, and cleans up the area where the flag is used for loading the firewall class.

2011-01-28  Ed Leafe <ed@leafe.com>

	Added a test that checks for localized strings in the source code that contain position-based string formatting placeholders. If found, an exception message is generated that summarizes the problem, as well as the location of the problematic code. This will prevent future trunk commits from adding localized strings that cannot be properly translated.

2011-01-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes sure all instance and volume commands that raise not found are changed to show the ec2_id instead of the internal id.

2011-01-27  Jordan Rinke <jordan@openstack.org>

	Changed cpu limit to a static value of 100000 (100%) instead of using the vcpu value of 1. There is no weight/limit variable now so I see no other solution than the static max limit.

2011-01-27  Thierry Carrez <thierry@openstack.org>

	Make nova.virt.images fetch images from a Glance URL when Glance is used as the image service (rather than unconditionally fetch them from an S3/objectstore URL).

2011-01-27  John Dewey <john@dewey.ws>

	Make unit tests clean up their mess in /tmp after themselves.

2011-01-27  Soren Hansen <soren.hansen@rackspace.com>

	Make xml namespace match the API version requested.

2011-01-27  Sandy Walsh <sandy.walsh@rackspace.com>

	Missing import in xen plugin.

2011-01-27  Hisaharu Ishii <ishii.hisaharu@lab.ntt.co.jp>, Nachi Ueno <ueno.nachi@lab.ntt.co.jp>, Vishvananda Ishaya <vishvananda@gmail.com>

	Fix Bug #703037. ra_server is None

2011-01-27  Todd Willey <todd@ansolabs.com>

	Fix regression in s3 image service.  This should be a feature freeze exception.

2011-01-26  Dan Prince <dan.prince@rackspace.com>

	Fixes a stupid mistake I made when I moved this method from a module into a class.
	
	Thanks Dan for spotting it. 

2011-01-26  Sandy Walsh <sandy.walsh@rackspace.com>

	Simple little changes related to openstack api to work better with glance. 
	
	Fixes ImageID missing from Glance and int->string id problem.

2011-01-26  Sandy Walsh <sandy.walsh@rackspace.com>

	Simple little changes related to openstack api to work better with glance. 
	
	Fixes ImageID missing from Glance and int->string id problem.

2011-01-26  Todd Willey <todd@ansolabs.com>

	Add DescribeInstanceTypes to admin api.  This lets the dashboard know what sizes can be launched (using the -t flag in euca-run-instances, for example) and what resources they provide.

2011-01-26  Tushar Patil <tushar.vitthal.patil@gmail.com>

	Fix for LP Bug #699654

2011-01-25  Vishvananda Ishaya <vishvananda@gmail.com>

	This branch updates docs to reflect the db sync addition.  It additionally adds some useful errors to nova-manage to help people that are using old guides.  It wraps sqlalchemy errors in generic DBError. Finally, it updates nova.sh to use current settings.

2011-01-25  Soren Hansen <soren.hansen@rackspace.com>

	Add a host argument to virt drivers's init_host method. It will be set to the name of host it's running on.
	
	Make libvirt's init_host method go and look at what virtual machines are running when the compute worker starts up.
	
	This ensures firewalls are set up correctly for existing VM's. It also enables easier rolling upgrades.

2011-01-25  Vishvananda Ishaya <vishvananda@gmail.com>

	Wraps the NotFound exception at the api layer to print the proper instance id.  Does the same for volume.  Note that euca-describe-volumes doesn't pass in volume ids properly, so you will get no error messages on euca-describe-volumes with improper ids.  We may also need to wrap a few other calls as well.

2011-01-25  Ryan Lane <rlane@wikimedia.org

	Fixes issue with SNATTING chain not getting created or added to POSTROUTING when nova-network starts.

2011-01-25  Ilya Alekseyev <ialekseev@griddynamics.com>

	Fix for bug #702237 

2011-01-25  Soren Hansen <soren.hansen@rackspace.com>

	Perform same filtering for OUTPUT as FORWARD in iptables.
	
	This removes a way around the filtering for traffic originating on the guests's host (not from VM's on the same host, but traffic from the host itself).

2011-01-25  Rick Harris <rconradharris@gmail.com>

	This patch:
	
	1. Removes the krm.json file which maps machine images to kernel and ramdisks
	2. Adds support to pull kernel_id and ramdisk_id directly from Glance image record.
	
	Note: This patch is dependent upon this bug in Glance being fixed: https://bugs.launchpad.net/glance/+bug/706192

2011-01-25  Tushar Patil <tushar.vitthal.patil@gmail.com>

	In instance chains and rules for ipv4 and ipv6, ACCEPT target was missing.

2011-01-25  Ryan Lane <rlane@wikimedia.org

	Fixes project and role checking when a user's naming attribute is not uid.

2011-01-25  John Dewey <john@dewey.ws>

	I am new to nova, and wanted to fix a fairly trivial bug in order to understand the process.
	
	Corrected some white space issues which pep8 found.
	
	John

2011-01-25  Soren Hansen <soren.hansen@rackspace.com>

	Set the default number of IP's to to reserve for VPN to 0.

2011-01-25  Vishvananda Ishaya <vishvananda@gmail.com>

	Switches from project_get_network to network_get_by_instance, which actually works with all networking modes.  Also removes a couple duplicate lines from a bad merge.

2011-01-25  Ed Leafe <ed@leafe.com>

	Localized strings that employ formatting should not use positional arguments, as they prevent the translator from re-ordering the translated text; instead, they should use mappings (i.e., dicts). This change replaces all localized formatted strings that use more than one formatting placeholder with a mapping version.

2011-01-24  Trey Morris <trey.morris@rackspace.com>

	the net_managers expect different args to create_networks, so nova-manage's call to net_manager.create_networks was changed to use named args to prevent argument mismatching.

2011-01-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix describe_regions by changing renamed flags.  Also added a test to catch future errors.

2011-01-23  Ken Pepple <ken.pepple@gmail.com>

	allow docs to build in virtualenv
	prevent setup.py from failing with sphinx in virtualenv

2011-01-22  Rick Harris <rconradharris@gmail.com>

	This patch skips VM shutdown if already in the halted state.

2011-01-21  Rick Harris <rconradharris@gmail.com>

	This patch adds two flags:
	
	--xenapi_remap_vbd_dev
	--xenapi_remap_vbd_dev_prefix
	
	If the plugged-in VBD dev is wrong, these configs let your remap it on the fly. This works around a bug in Ubuntu Maverick: https://bugs.launchpad.net/ubuntu/+source/linux/+bug/684875

2011-01-21  Rick Harris <rconradharris@gmail.com>

	Adds gettext to pluginlib_nova.py. Fixes #706029.

2011-01-21  Thierry Carrez <thierry@openstack.org>

	No longer chmod 0777 instance directories, since nova works just fine without them.

2011-01-21  Anne Gentle <anne@openstack.org>

	Updated docs for db sync requirements; merged with Vish's similar doc updates

2011-01-21  Thierry Carrez <thierry@openstack.org>

	Change default log formats so that:
	* they include a timestamp (necessary to correlate logs)
	* no longer display version on every line (shorter lines)
	* use [-] instead of [N/A] (shorter lines, less scary-looking)
	* show level before logger name (better human-readability)
	
	Display version once at node startup time instead.
	Fix description of the log format flags.

2011-01-20  Todd Willey <todd@ansolabs.com>

	Fix metadata using versions other than /later.  Patch via ~ttx

2011-01-20  Ryan Lane <rlane@wikimedia.org

	Fixes issue with instance creation throwing errors when non-default groups are used.

2011-01-20  Ryan Lane <rlane@wikimedia.org

	Fixes issue with describe_instances requiring an admin context.

2011-01-20  jaypipes@gmail.com

	Finds and fixes remaining strings for i18n. Fixes bug #705186

2011-01-20  Soren Hansen <soren.hansen@rackspace.com>

	Pass a PluginManager to nose.config.Config(). This lets us use plugins like coverage, xcoverage, etc.

2011-01-20  Anthony Young <sleepsonthefloor@gmail.com>, Vishvananda Ishaya <vishvananda@gmail.com>

	Added changes to make errors and recovery for volumes more graceful:
	
	* If an error occurs while creating our exporting a volume, volume['status'] is set to 'error,' rather than leaving it in 'creating.'  Similarly, if an error occurs while deleting, volume['status'] is set to 'error_deleting'
	* Gracefully handle condition where iscsi export has already been removed, or has never successfully been created, in ISCSIDriver.remove_export
	* In ISCSIDriver.ensure_export, gracefully handle situation where an iscsi_target is nil.  This occurs when there is an error creating a volume that prevents the target from being assigned.
	* Add nova-manage volume commands: delete and reattach
	** delete can be used to delete volumes that are in error state, since users can only delete volumes flagged as 'available'
	** reattach can be used after host reboot to reattach volumes 
	
	Note that I didn't implement rollback as the original bug suggested, but this code accomplishes the same objectives IMO by making it more clear when errors occur and providing tools for dealing with certain common error conditions.

2011-01-20  Soren Hansen <soren.hansen@rackspace.com>

	Exclude vcsversion.py from pep8 check. It's not compliant, but out of our control.

2011-01-20  Soren Hansen <soren.hansen@rackspace.com>

	Include paste config in tarball.

2011-01-19  jaypipes@gmail.com

	Fixes for bugs:
	
	* Bug #704422: nova-direct-api: AttributeError: 'module' object has no attribute 'ComputeAPI'
	* Bug #704424: bin/stack: AttributeError: port
	* Bug #704447: bin/stack: urllib2.HTTPError when issuing reflection request

2011-01-19  Soren Hansen <soren.hansen@rackspace.com>

	Return non-zero if either unit tests or pep8 fails.

2011-01-19  Soren Hansen <soren.hansen@rackspace.com>

	Eagerly load fixed_ip.network in instance_get_by_id.

2011-01-19  Kost <kost@isi.edu>

	Add paste and paste.deploy installation to nova.sh, needed for api server.

2011-01-19  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes **params unpacking to ensure all kwargs are strings for compatibility with python 2.6.1

2011-01-19  Soren Hansen <soren.hansen@rackspace.com>

	Refactor run_tests.sh to allow us to run an extra command after the tests.
	
	Run pep8 after unit tests in run_tests.sh.
	
	Fix setup.py to be PEP-8 compliant.

2011-01-19  Soren Hansen <soren.hansen@rackspace.com>

	Add an apply_instance_filter method to NWFilter driver.
	
	Adjust unit tests for both firewall drivers to actually exercise these
	code paths.

2011-01-19  Vishvananda Ishaya <vishvananda@gmail.com>

	Replace an old use of ec2_id with id in describe_addresses.

2011-01-19  Andy Smith <code@term.ie>

	Allows moving from the Austin-style db to the Bexar-style.
	
	Prevents the db from being created automatically when services run.
	
	Adds nova-manage db sync and nova manage db version to bring the db up-to-date and to check the current version. Must be run with the same privileges as the services who will access the database (or you need to chmod the db afterwards if sqlite)

2011-01-18  Soren Hansen <soren.hansen@rackspace.com>

	Enable the use_ipv6 flag in unit tests by default.

2011-01-18  Vishvananda Ishaya <vishvananda@gmail.com>

	This disables ipv6 by default.  Most use cases will not need it on and it makes dependencies more complex.

2011-01-18  Andy Smith <code@term.ie>

	The live_migration branch ( https://code.launchpad.net/~nttdata/nova/live-migration/+merge/44940 ) was not ready to be merged.
	
	Outstanding issues:
	- many style violations, especially in docstrings (leading spaces, extra newlines)
	- no test coverage
	- unusual defaults in the database columns (-1?)
	- unusual naming "phy_resource"
	
	The database changes in particular should preclude the original from being merged until they are correct, and for a patch of this scope some tests are really necessary for the new functionality.
	
	The patch needs further review and should not be rushed in for bexar as it commits us to a variety of data model decisions that require more input.

2011-01-18  Ewan Mellor <ewan.mellor@citrix.com>, Salvatore Orlando <salvatore.orlando@eu.citrix.com>

	Implement support for streaming images from Glance when using the XenAPI virtualization backend, as per the bexar-xenapi-support-for-glance blueprint.
	
	Images may be streamed raw, or will be streamed into the right place to allow room for an MBR and partition table, if using non-raw images.  PV vs HVM detection now occurs on the image, immediately after it has been streamed.  External kernel / ramdisk are also supported in this mode.
	
	Unit test changes include a partial Glance simulator, which is stubbed in place of glance.client.Client.  This allows us to pass through the VM spawn path with either glance or objectstore backends enabled; the unit tests now cover both.  A dependency upon glance has been added to pip-requires, in order to pull the Glance client code into the venv.
	
	This includes minor fixes to nova.image.glance.  This code is expected to be heavily reworked anyway with the image-service-use-glance-clients work.

2011-01-18  Vishvananda Ishaya <vishvananda@gmail.com>

	Works around the app-armor problem of requiring disks with backing files to be named appropriately by changing the name of our extra disks.
	
	disk is fine, as is disk.local and disk.rescue.

2011-01-18  Todd Willey <todd@ansolabs.com>

	Add refresh_security_group_* methods to nova/virt/fake.py, as FakeConnection is the reference for documentation and method signatures that should be implemented by virt connection drivers.

2011-01-18  Vishvananda Ishaya <vishvananda@gmail.com>

	This removes the need for the custom udev rule for iscsi devices.  It instead attaches the device based on /dev/disk/by-path/ which should make the setup of nova-volume a little easier.

2011-01-18  Kei <masumotok@nttdata.co.jp>, masumotok <masumotok@nttdata.co.jp>, Muneyuki Noguchi <noguchimn@nttdata.co.jp>, root <masumotok@nttdata.co.jp>

	Risk of Regression: This patch don?t modify existing functionlities, but I have added some.
	1. nova.db.service.sqlalchemy.model.Serivce (adding a column to database)
	2. nova.service ( nova-compute needes to insert information defined by 1 above)
	
	So, db migration is necessary for existing user, but just adding columns.

2011-01-17  Todd Willey <todd@ansolabs.com>

	Change where paste.deploy factories live and how they are called.  They are now in the nova.wsgi.Application/Middleware classes, and call the __init__ method of their class with kwargs of the local configuration of the paste file.

2011-01-17  Todd Willey <todd@ansolabs.com>

	Further decouple api routing decisions and move into paste.deploy configuration.  This makes paste back the nova-api binary.

2011-01-17  Rick Harris <rconradharris@gmail.com>

	The Openstack API requires image metadata to be returned immediately after an image-create call.
	
	This is accomplished by having the ImageService create a 'queued' image in Glance.
	
	When the image is subsequently uploaded, the image will go from 'queued' -> 'saving' -> 'queued'.
	
	Related Future Work:
	
	The ImageService needs to be cleaned up so that there is a canonical set of attributes (id, status, etc), and a canonical set of values ('queued', 'saving', etc). Right now, EC2 is fairly coupled to LocalImageService and S3ImageService while OpenStackAPI is coupled to GlanceImageService; ideally, we should be able mix-and-match from any of these.

2011-01-15  Andy Smith <code@term.ie>, termie <code@term.ie>

	Adds a developer interface with direct access to the internal inter-service APIs and a command-line tool based on reflection to interact with them.
	
	Example output from command-line tool:
	
	(.nova-venv)termie@preciousroy:p/nova/easy_api % ./bin/stack
	usage: stack [options] <controller> <method> [arg1=value arg2=value]
	
	`stack help` should output the list of available controllers
	`stack <controller>` should output the available methods for that controller
	`stack help <controller>` should do the same
	`stack help <controller> <method>` should output info for a method
	
	./bin/stack:
	-?,--[no]help: show this help
	--[no]helpshort: show usage only for this module
	--[no]helpxml: like --help, but generates XML output
	--host: Direct API host
	(default: '127.0.0.1')
	--port: Direct API host
	(default: '8001')
	(an integer)
	--project: Direct API project
	(default: 'proj1')
	--user: Direct API username
	(default: 'user1')
	
	Available controllers:
	reflect   Reflection methods to list available methods.
	compute   API for interacting with the compute manager.
	
	(.nova-venv)termie@preciousroy:p/nova/easy_api % ./bin/stack help reflect
	Available methods for reflect:
	get_controllers   List available controllers.
	get_methods       List available methods.
	get_method_info   Get detailed information about a method.
	
	(.nova-venv)termie@preciousroy:p/nova/easy_api % ./bin/stack help reflect get_method_info
	get_method_info(method):
	
	Get detailed information about a method.
	
	(.nova-venv)termie@preciousroy:p/nova/easy_api % ./bin/stack reflect get_method_info method=/reflect/get_method_info
	{u'args': [[u'method']],
	u'doc': u'Get detailed information about a method.',
	u'name': u'get_method_info',
	u'short_doc': u'Get detailed information about a method.'}

2011-01-14  Vishvananda Ishaya <vishvananda@gmail.com>

	This branch fixes two outstanding bugs in compute.  It also fixes a bad method signature in network and removes an unused method in cloud.

2011-01-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Re-removes TrialTestCase.  It was accidentally added in by some merges and causing issues with running tests individually.

2011-01-14  Josh Kearney <josh.kearney@rackspace.com>

	Create and use a generic handler for RPC calls to compute.

2011-01-14  Ed Leafe <ed@leafe.com>

	Implements the blueprint for enabling the setting of the root/admin password on an instance.
	
	It uses a new xenapi plugin 'agent' that handles communication to/from the agent running on the guest. 

2011-01-14  Nachi Ueno <ueno.nachi@lab.ntt.co.jp>, Nachi Ueno <ueno.nachi@lab.ntt.co.jp>, Hisaharu Ishii <ishii.hisaharu@lab.ntt.co.jp>, nova <ueno.nachi@lab.ntt.co.jp>, Koji Iida <iida.koji@lab.ntt.co.jp>, NTT PF Lab. <ueno.nachi@lab.ntt.co.jp>

	OpenStack Compute (Nova) IPv4/IPv6 dual stack support
	http://wiki.openstack.org/BexarIpv6supportReadme
	
	Tested with
	unit test
	smoke test
	
	No conflict with current branch r 562.
	Fixed comment by Soren and Vish

2011-01-14  MORITA Kazutaka <morita.kazutaka@gmail.com>

	This change introduces support for Sheepdog (distributed block storage
	system) which is proposed in
	https://blueprints.launchpad.net/nova/+spec/sheepdog-support
	
	
	Requirements:
	
	- libvirt 0.8.7 or later
	- qemu 0.13.0 or later
	
	
	How to test:
	
	1. install Sheepdog
	
	The software is available from SourceForge.net:
	https://sourceforge.net/projects/sheepdog/files/
	
	See also:
	http://wiki.qemu.org/Features/Sheepdog/Getting_Started#Install
	
	2. run the sheepdog daemon on each hosts
	
	$ sheep /store_dir
	
	/store_dir is a directory to store sheepdog objects. The directory
	must be on the filesystem with an xattr support.
	
	3. format the sheepdog storage
	
	$ collie cluster format --copies=3
	
	4. run nova-volume
	
	$ nova-volume --volume_driver=nova.volume.driver.SheepdogDriver

2011-01-14  Vishvananda Ishaya <vishvananda@gmail.com>

	This modifies libvirt to use CoW images instead of raw images.  This is much more efficient and allows us to use the snapshotting capabilities available for qcow2 images.  It also changes local storage to be a separate drive instead of a separate partition.
	
	I'm proposing this branch for review to get feedback.  I may have inadvertently broken a few things.  Comments and possible issues:
	
	1. I haven't tested the other hypervisors.  I may have broken libvirt xen support and uml support with this patch.
	2. Is it useful to have a use_cow_images param, or should it just be automatic for qemu/kvm and turned off for everything else.
	3. create_image is a large annoying method.  I tried to clean it up a bit, but it could probably use a bit more refactoring.
	4. disk.py seems to be only used by the hypervisors, so perhaps it should move into virt dir.
	5. disk.py/partition() is unused now. Should we leave it in or throw it away?
	
	Comments welcome

2011-01-13  Soren Hansen <soren.hansen@rackspace.com>

	Add a new method to firewall drivers to tell them to stop filtering a particular instance. Call it when an instance has been destroyed.
	
	Use dict()s (keyed off id's) instead of set()s for keeping track of instances and security groups in the iptables firewall driver. __eq__ for objects from sqlalchemy fetched in different sessions doesn't work as expected, so I needed to explicitly filter on ID.

2011-01-13  Andy Smith <code@term.ie>

	Fixes related to how EC2 ids are displayed and dealt with.
	
	Additionally adds two flags that define a template string that is used for the internal naming of things (like the volume name of a logical volume on disk), default being similar to the EC2 format, so that the ids are easy to match while testing when you may need to manually delete or check something.

2011-01-13  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes broken call to __generate_rc in auth manager.

2011-01-13  Anthony Young <sleepsonthefloor@gmail.com>

	Fixes bug #701055.  Moves code for instance termination inline so that the manager doesn't prematurely mark an instance as deleted.  Prematurely doing so causes find calls to fail, prevents instance data from being deleted, and also causes some other issues.

2011-01-13  Andy Smith <code@term.ie>

	Fixes a typo in the name of a variable.

2011-01-12  Soren Hansen <soren.hansen@rackspace.com>

	Fix test failures on Python 2.7 by eagerly loading the fixed_ip attribute on instances. No clue why it doesn't affect python 2.6, though.

2011-01-12  Todd Willey <todd@ansolabs.com>

	Initialize logging in nova-manage so we don't see errors about missing handlers.

2011-01-12  Trey Morris <trey.morris@rackspace.com>

	_wait_with_callback was changed out from under suspend/resume. fixed.

2011-01-12  Josh Durgin <joshd@hq.newdream.net>

	This branch adds a backend for using RBD (RADOS Block Device) volumes in nova via libvirt/qemu.
	This is described in the blueprint here: https://blueprints.launchpad.net/nova/+spec/ceph-block-driver
	
	Testing requires Ceph and the latest qemu and libvirt from git. Instructions for installing these can be found on the Ceph wiki (http://ceph.newdream.net/wiki/#Getting_Ceph and http://ceph.newdream.net/wiki/QEMU-RBD).

2011-01-12  Sandy Walsh <sandy.walsh@rackspace.com>

	My previous modifications to novarc had CLOUDSERVER_AUTH_URL pointing to the ec2 api port. Now it's correctly pointing to os api port.

2011-01-12  Ilya Alekseyev <ialekseev@griddynamics.com>, Eldar Nugaev <enugaev@griddynamics.com>

	Added support of availability zones for compute.
	models.Service got additional field availability_zone and was created ZoneScheduler that make decisions based on this field. 
	Also replaced fake 'nova' zone in EC2 cloud api.

2011-01-12  Anne Gentle <anne@openstack.org>

	Had to abandon the other branch (~annegentle/nova/newscript) because the diffs weren't working right for me. This is a fresh branch that should be merged correctly with trunk. Thanks for your patience. :)

2011-01-12  root <sleepsonthefloor@gmail.com>, Anthony Young <sleepsonthefloor@gmail.com>, Jesse Andrews <anotherjesse@gmail.com>

	This branch adds web based serial console access.  Here is an overview of how it works (for libvirt):
	
	1. User requests an ajax console for an instance_id (either through OS api, or tools/euca-get-ajax-console)
	a. api server calls compute worker to complete request
	b. compute worker parses an instance's xml to locate its pseudo terminal (/dev/pts/x)
	c. compute worker spawns an ajaxterm daemon, bound to a random port in a specified range.  socat is used to connect to /dev/pts/x.  Note that ajaxterm was modified in the following ways:
	i. dies after 5 minutes of inactivity
	ii. now requires token authentication.  Previously it was trivial to hijack an ajaxterm
	d. compute worker returns ajaxterm connect information to the api server: port, host, token
	e. api server casts connect information to the nova-ajax-console-proxy (a new service)
	f. api server returns a url for the ajaxterm (eg. http://nova-ajax-console-proxy/?token=123)
	2. User now has a url, and can paste it in a browser
	a. Browser sends request to https://nova-ajax-console-proxy/?token=123
	b. nova-ajax-console-proxy maps token to connect information
	c. nova-ajax-console-proxy constructs a proxy to the ajaxterm that is running on the host machine.  This is now done with eventlet, though previously it was done using twisted
	3. User interacts with console through web browser
	
	
	NOTE: For this to work as expected, serial console login must be enabled in the instance.  Instructions for how to do this on ubuntu can be found here: https://help.ubuntu.com/community/SerialConsoleHowto.  Note that you must actively log out of the serial console when you are finished, otherwise the console will remain open even after the ajaxterm term session has ended.
	
	Also note that nova.sh has been modified in this branch to launch nova-ajax-console-proxy.

2011-01-12  Ryan Lane <rlane@wikimedia.org>, Ryan Lane <rlane@wikimedia.org

	Changing DN creation to do searches for entries.
	
	This change adds additional interoperability (as many directory servers and LDAP admins use cn, or another attribute, as the naming attribute). DN creation will incur a slight performance penalty for doing so, as DNs must be searched for now. User and project creation skip this performance penalty, as there is no need to search for an entry that is being created.

2011-01-12  Lorin Hochstein <lorin@isi.edu>

	Fixes bug #701575: run_tests.sh fails with a meaningless error if virtualenv is not installed. Proposed fix tries to use easy_install to install virtualenv if not present. 
	
	Test by doing "run_tests.sh -V" on a system that has easy_install installed but not virtualenv. 

2011-01-11  Todd Willey <todd@ansolabs.com>

	Quick bugfix.  Also make the error message more specific and unique in the equivalent code in the revoke method.

2011-01-11  Sandy Walsh <sandy.walsh@rackspace.com>

	Read Full Spec for implementation details and notes on how to boot an instance using OS API.
	http://etherpad.openstack.org/B2RK0q1CYj
	
	Look at these notes for known issues:
	http://etherpad.openstack.org/BXOU0TTj9M

2011-01-11  Soren Hansen <soren.hansen@rackspace.com>

	Fixed a number of issues with the iptables firewall backend:
	* Port specifications for firewalls come back from the data store as integers, but were compared as strings.
	* --icmp-type was misspelled as --icmp_type (underscore vs dash)
	* There weren't any unit tests for these issues.

2011-01-11  Monsyne Dragon <mdragon@rackspace.com>

	Implementation of xs-console blueprint (adds support for console proxies like xvp)
	
	
	If you spin up the nova-console service, you should be able to see the xvp.conf being edited, and the xvp daemon started/stopped if you exercise the openstack console api (consoles sub-resource on servers) 

2011-01-11  Vishvananda Ishaya <vishvananda@gmail.com>

	A few more changes to the smoeketests.  Allows smoketests to find the nova package from the checkout.  Adds smoketests for security groups.  Also fixes a couple of typos.

2011-01-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes the metadata forwarding to work by default.
	
	This branch also moves get_my_ip into flags.py from utils.py and sets up a flag called my_ip.  Any flag that was using get_my_ip can just use '$my_ip' as the default value.  This allows a user to change all ips by changing one flag.

2011-01-11  Ryan Lane <rlane@wikimedia.org

	Adds support to nova-manage to modify projects

2011-01-10  Sandy Walsh <sandy.walsh@rackspace.com>

	xenapi_conn was not terminating utils/LoopingCall when an exception was occurring. This was causing the eventlet Event to have send_exception() called more than once (a no-no).
	
	This would have affected more than just pause/unpause, but any XenApi call that raised an exception.

2011-01-10  Todd Willey <todd@ansolabs.com>

	Bugfix.

2011-01-10  jaypipes@gmail.com, Monty Taylor <mordred@inaugust.com>

	Adds the requisite infrastructure for automating translation templates import/export to Launchpad.

2011-01-10  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes describe_instances to filter by a list of instance_ids.
	
	Also adds a test to verify that we don't break this again.

2011-01-10  Vishvananda Ishaya <vishvananda@gmail.com>

	Late import module for register_models() so it doesn't create the db before flags are loaded.
	
	This is a quick fix because trunk is broken for anything but the default database.  I really think we ultimately need to remove all code that runs in __init__.py

2011-01-10  Vishvananda Ishaya <vishvananda@gmail.com>

	Checks for existence of volume group using vgs instead of checking to see if /dev/nova-volumes exists.  The dev is created by udev and isn't always there even if the volume group does exist.

2011-01-10  Soren Hansen <soren.hansen@rackspace.com>, Soren Hansen <soren.hansen@rackspace.com>

	Add a new firewall backend for libvirt, based on iptables.

2011-01-09  Ken Pepple <ken.pepple@gmail.com>

	fixes Document make configuration by updating nova version mechanism to conform to rev530 update

2011-01-08  Vishvananda Ishaya <vishvananda@gmail.com>

	Return proper region info in describe_regions.

2011-01-07  Soren Hansen <soren.hansen@rackspace.com>, Todd Willey <todd@ansolabs.com>

	Adds a mechanism to programmatically determine the version of Nova. The designated version is defined in nova/version.py. When running python setup.py from a bzr checkout, information about the bzr branch is put into nova/vcsversion.py which is conditionally imported in nova/version.py.
	
	In short, you can now do:
	
	>>> import nova.version
	>>> nova.version.canonical_version_string()
	'2011.1'
	>>> nova.version.version_string()
	'2011.1-dev'
	>>> nova.version.version_string_with_vcs()
	u'2011.1-newlog2:soren@linux2go.dk-20110107130049-g2cbri7t80vsg2h1'
	
	It's also consumed by the docs and setup.py, so this ought to be the canonical place for updating version information from now on.

2011-01-07  Ryan Lane <rlane@wikimedia.org, Ryan Lane <rlane@wikimedia.org>

	Fixes issue in trunk with downloading s3 images for instance creation.

2011-01-07  Todd Willey <todd@ansolabs.com>

	Wrap logs so we can:
	* use a "context" kwarg to track requests all the way through the system
	* use a custom formatter so we get the data we want (configurable with flags)
	* allow additional formatting for debug statements for easer debugging
	* add an AUDIT level, useful for noticing changes to system components
	* use named logs instead of the general logger where it makes sesnse

2011-01-07  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #699910: Nova RPC layer silently swallows exceptions
	
	Log exceptions thrown during message handling.

2011-01-07  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #699912: When failing to connect to a data store, Nova doesn't log which
	data store it tried to connect to
	
	Log FLAGS.sql_connection when failing to connect, to aid debugging.

2011-01-07  Josh Kearney <josh.kearney@rackspace.com>

	Include date in API action query.

2011-01-07  Trey Morris <trey.morris@rackspace.com>

	This branch implements lock functionality. The lock is stored in the compute worker database. Decorators have been added to the openstack API actions which alter instances in any way.

2011-01-06  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes format_instances error by passing reservation_id as a kwarg instead of an arg.  Also removes extraneous yields in test_cloud that were causing tests to pass with broken code.

2011-01-06  Chiradeep Vittal <chiradeep@cloud.com>, Chiradeep Vittal <chiradeep@cloud.com>

	Introduces basic support for spawning, rebooting and destroying vms when using Microsoft Hyper-V as the hypervisor. 
	Images need to be in VHD format. Note that although Hyper-V doesn't accept kernel and ramdisk
	separate from the image, the nova objectstore api still expects an image to have an associated aki and ari. You can use dummy aki and ari images -- the hyper-v driver won't use them or try to download them.
	Requires Python's WMI module.

2011-01-06  Cory Wright <corywright@gmail.com>

	This addition to the docs clarifies that it is a requirement for contributors to be listed in the Authors file before their commits can be merged to trunk.

2011-01-05  Devin Carlen <devin.carlen@gmail.com>

	Removed dependencies on nova server components for the admin client.

2011-01-05  Todd Willey <todd@ansolabs.com>

	Remove stale doc files so the autogeneration extension for sphinx will work properly.

2011-01-05  Eric Day <eday@oddments.org>

	This branch contains the internal API cleanup branches I had previously proposed, but combined together and with all the UUID key replacement ripped out. This allows multiple REST interfaces (or other tools) to use the internal API directly, rather than having the logic tied up in the ec2 cloud.py file.

2011-01-05  Ed Leafe <ed@leafe.com>

	Created a XenAPI plugin that will allow nova code to read/write/delete from xenstore records for a given instance. Added the basic methods for working with xenstore data to the vmops script, as well as plugin support to xenapi_conn.py

2011-01-05  Josh Kearney <josh.kearney@rackspace.com>

	Recover from a lost data store connection.

2011-01-03  Josh Kearney <josh.kearney@rackspace.com>

	Fixes LP688545.

2011-01-03  Soren Hansen <soren.hansen@rackspace.com>

	Make sure we point to the right PPA's everywhere.

2011-01-03  Todd Willey <todd@ansolabs.com>

	Uses paste.deploy to make application running configurable.  This includes the ability to swap out middlewares, define new endpoints, and generally move away from having code to build wsgi routers and middleware chains into a configurable, extensible method for running wsgi servers.

2011-01-03  Ryan Lucio <rlucio@internap.com>

	Adds the pool_recycle option to the sql engine startup call.  This enables connection auto-timeout so that connection pooling will work properly.  The recommended setting (per sqlalchemy FAQ page) has been provided as a default for a new configuration flag.  What this means is that if a db connection sits idle for the configured # of seconds, the engine will automatically close the connection and return it to the available thread pool.  See Bug #690314 for info.
	
	The fix was tested and verified on multi-node deployments of Austin and Bexar with MySQL, and it was also verified that the change does not affect sqlite users (dev environment testing only).

2011-01-03  Todd Willey <todd@ansolabs.com>

	Add burnin support.  Services are now by default disabled, but can have instances and volumes run on them using availability_zone = nova:HOSTNAME.  This lets the hardware be put through its paces without being put in the generally available pool of hardware.  There is a 'service' subcommand for nova-manage where you can enable, disable, and list statuses of services.

2011-01-03  Cory Wright <corywright@gmail.com>

	Several documentation corrections and formatting fixes.

2010-12-31  Eric Day <eday@oddments.org>

	Ignore CA/crl.pem

2010-12-31  Cerberus <matt.dietz@rackspace.com>

	Auth Tokens assumed the user_id was an int, not a string.

2010-12-31  Josh Kearney <josh.kearney@rackspace.com>

	Make InstanceActions and live diagnostics available through the Admin API.

2010-12-30  termie <code@term.ie>

	Cleans up the output of run_tests.sh to look closer to Trial.
	
	Example output:
	
	VolumeTestCase
	test_concurrent_volumes_get_different_targets               ok
	test_create_delete_volume                                   ok
	test_multi_node                                             ok
	test_run_attach_detach_volume                               ok
	test_too_big_volume                                         ok
	test_too_many_volumes                                       ok
	XenAPIVMTestCase
	test_list_instances_0                                       ok
	test_spawn                                                  ok
	XenAPIVolumeTestCase
	test_attach_volume                                          ok
	test_attach_volume_raise_exception                          ok
	test_create_iscsi_storage                                   ok
	test_parse_volume_info_raise_exception                      ok
	
	----------------------------------------------------------------------
	Ran 232 tests in 82.677s
	
	Launchpad is removing a bunch of spaces from the output, but the 'ok' parts are all lined up in the 65th column

2010-12-30  Rick Harris <rconradharris@gmail.com>

	This patch is beginning of XenServer snapshots in nova. It adds:
	
	1. A snapshot() method to the compute API
	2. Snapshot to the compute drivers(), stubs for libvirt and fake, and an implementation for xenapi_conn.
	3. A `glance` XenServer plugin (modeled after the current `objectstore` plugin).
	
	To test functionally you will need to be running both the Glance API and the Glance Registry.
	
	In order to use the cloudservers tool-chain (cloudservers command-line utility, openstack-api, etc), you will need create a project called 'openstack' or override FLAGS.default_project.
	
	You can verify that snapshots work by using the cloudservers command-line utility to run:
	cloudservers image-create <instance-id> <my snapshot name>
	
	The utility itself will generate an exception since we're not returning the appropriate metadata yet (that will be a future commit); however, you can confirm that the snapshot worked by checking the compute-service logs, and verifying the snapshot resides in the glance fs-store directory.

2010-12-29  Todd Willey <todd@ansolabs.com>

	fix lp:695182, scheduler tests needed to DECLARE flag to run standalone.

2010-12-29  Ryan Lucio <rlucio@internap.com>

	This branch fixes an issue where VM creation fails because of a missing flag definition for 'injected_network_template'.  See Bug #695467 for more info.  

2010-12-29  Cerberus <matt.dietz@rackspace.com>

	Changes and error fixes to help ensure basic parity with the Rackspace API. Some features are still missing, such as shared ip groups, and will be added in a later patch set. 

2010-12-29  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #694880: nova-compute now depends upon Cheetah even when not using libvirt
	
	Only import Cheetah when needed, as we do already with libvirt and libxml2.  This ensures that users of other virt backends don't need Cheetah to run nova-compute.
	
	Resubmitted with pep8 violations fixed.

2010-12-28  Soren Hansen <soren.hansen@rackspace.com>

	Address bug #695157 by using a blank request class and setting an empty request path.
	
	This fixes the test suite in environments with webob >= 1.0 (e.g. Ubuntu Natty).
	
	(Thanks for Greg Holt for the suggestion)

2010-12-28  Cory Wright <corywright@gmail.com>, Antony Messerli <ant@openstack.org>

	This commit introduces scripts to apply XenServer host networking protections.  

2010-12-28  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #694890: run_tests.sh sometimes doesn't pass arguments to nosetest
	
	Change the argument parsing in run_tests.sh so that we explicitly gather
	the arguments that aren't meant for run_tests.sh, and pass them on to
	nosetests.

2010-12-28  Trey Morris <trey.morris@rackspace.com>

	I've added suspend along with a few changes to power state as well. I can't imagine suspend will be controversial but I've added a new power state for "suspended" to nova.compute.power_states which libvirt doesn't use and updated the xenapi power mapping to use it for suspended state. I also updated the mappings in nova.api.openstack.servers to map PAUSED to "error" and SUSPENDED to "suspended". Thoughts there are that we don't currently (openstack API v1.0) use pause, so if somehow an instance were to be paused an error occurred somewhere, or someone did something in error. Either way asking the xenserver host for the status would show "paused". Support for more power states needs to be added to the next version of the openstack API. 
	
	merge notes:
	merge with trunk went well locally
	unittests passed locally
	testing of suspend succeeded locally
	
	Notes for testing:
	Suspending an instance requires PV drivers.
	If using the cloudservers API, suspend and resume are not implemented. I tested by modifying in place nova.api.openstack.servers after pulling my branch. I made pause() and unpause() immediately return self.suspend() and self.resume(). Afterwards cloudserver pause (id) and cloudserver unpause (id) will perform the suspend/resume, and you can watch the compute worker log for info on what is happening.
	
	SAMPLE LOG OUTPUT FOR PAUSE/UNPAUSE +++++++++++++++++++++
	DEBUG:root:instance 1178831109: pausing
	INFO:root:Task OpaqueRef:ba3b1595-0d70-574a-aaca-27442d04be87 status: success.
	INFO:root:(VM_UTILS) xenserver vm state -> |Paused|
	INFO:root:(VM_UTILS) xenapi power_state -> |3|
	DEBUG:root:instance 1178831109: unpausing
	INFO:root:Task OpaqueRef:2d9cb792-0ce5-be23-6c50-3dc52cf1535c status: success.
	INFO:root:(VM_UTILS) xenserver vm state -> |Running|
	INFO:root:(VM_UTILS) xenapi power_state -> |1|
	
	SAMPLE LOG OUTPUT FOR SUSPEND/RESUME +++++++++++++++++++++
	DEBUG:root:instance 1178831109: suspending
	INFO:root:Task OpaqueRef:bc5d51da-922f-c9fb-f07c-aaa027fde601 status: success.
	INFO:root:(VM_UTILS) xenserver vm state -> |Suspended|
	INFO:root:(VM_UTILS) xenapi power_state -> |7|
	DEBUG:root:instance 1178831109: resuming
	INFO:root:Task OpaqueRef:4e5a3af8-baed-c144-30ea-63637390f6c8 status: success.
	INFO:root:(VM_UTILS) xenserver vm state -> |Running|
	INFO:root:(VM_UTILS) xenapi power_state -> |1|

2010-12-28  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	fix bug #lp694311

2010-12-27  Trey Morris <trey.morris@rackspace.com>

	Cleans up nova.api.openstack.images and fix it to work with cloudservers api. Previously "cloudservers image-list" wouldn't work, now it will. There are mappings in place to handle s3 or glance/local image service. In the future when the local image service is working, we can probably drop the s3 mappings.

2010-12-27  Salvatore Orlando <salvatore.orlando@eu.citrix.com>

	Fixed after Jay's review. 
	Integrated code from Soren (we now use the same 'magic number' for images without kernel & ramdisk.

2010-12-25  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	Fix Bug #693963

2010-12-24  David Pravec <David.Pravec@danix.org>

	Make nova work even when user has LANG or LC_ALL configured
	
	Some commands are having different results when used in another language environment.
	For example ifconfig output parsing fails in my language.
	Also unittest using cat failed, as it didnt expect czech language in the error message.
	
	This small patch makes it work.
	Also adding myself to 'Authors' file

2010-12-23  Cerberus <matt.dietz@rackspace.com>, mdietz <matt.dietz@rackspace.com>

	Moves implementation specific Openstack API code from the middleware to the drivers. Also cleans up a few areas and ensures all the API tests are passing again. 

2010-12-23  Eric Day <eday@oddments.org>, Monty Taylor <mordred@inaugust.com>

	Trying to remove twisted dependencies, this gets everything working under nosetests.

2010-12-23  Ryan Lane <rlane@wikimedia.org>

	Simplifies and improves ldap schema.

2010-12-23  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	xenapi iscsi support + unittests

2010-12-23  Vishvananda Ishaya <vishvananda@gmail.com>

	There were a few unclaimed addresses in mailmap.
	
	<vishvananda@gmail.com> is me from my vm
	<sleepsonthefloor@gmail.com> is Anthony Young
	
	<rlane@wikimedia.org> is Ryan Lane.  If I can find a real email address for him, I'll change that one as well.

2010-12-23  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes reboot (and rescue) to work even if libvirt doesn't know about the instance and the network doesn't exist.

2010-12-23  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes reboot (and rescue) to work even if libvirt doesn't know about the instance and the network doesn't exist.

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds a flag to use the X-Forwarded-For header to find the ip of the remote server.  This is needed when you have multiple api servers with a load balancing proxy in front.  It is a flag that defaults to False because if you don't have a sanitizing proxy in front, users could masquerade as other ips by passing in the header manually.

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>, Eric Day <eday@oddments.org>

	Moves the ip allocation requests to the from the api host into calls to the network host made from the compute host.

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Optimize creation of nwfilter rules so they aren't constantly being recreated.

2010-12-22  root <vishvananda@gmail.com>, Vishvananda Ishaya <vishvananda@gmail.com>

	WSGI middleware for lockout after failed authentications of ec2 access key.

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Modifies nova-network to recreate important data on start.

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Puts the creation of nova iptables chains into the source code and cleans up rule creation.  This makes nova play more nicely with other iptables rules that may be created on the host.
	
	Additionally adds support via flag for specifying a dns server to use for dnsmasq instead of just using the default /etc/hosts and dns server that the host is using.
	
	Note: based on lp:~vishvananda/nova/project-vpns to simplify merging of flag changes.

2010-12-22  Thierry Carrez <thierry@openstack.org>

	Populate user_data field from run-instances call parameter, default to empty string to avoid metadata base64 decoding failure, LP: #691598

2010-12-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes per-project vpns (cloudpipe) and adds manage commands and support for certificate revocation.

2010-12-22  jaypipes@gmail.com

	Fixes documentation builds for gettext...

2010-12-22  Josh Kearney <josh.kearney@rackspace.com>

	Log all XenAPI actions to InstanceActions.

2010-12-22  jaypipes@gmail.com

	All merged with trunk and let's see if a new merge prop (with no pre-req) works..

2010-12-21  Vishvananda Ishaya <vishvananda@gmail.com>

	This stops the nova-network dhcp ip from being added to all of the compute hosts.

2010-12-21  Josh Kearney <josh.kearney@rackspace.com>

	Added InstanceDiagnostics and InstanceActions DB models.

2010-12-20  Justin Santa Barbara <justin@fathomdb.com>, Justin Santa Barbara <justin@fathomdb.com>, Rick Clark <rick@openstack.org>, Soren Hansen <soren.hansen@rackspace.com>, Soren Hansen <soren.hansen@rackspace.com>

	Add raw disk image support.

2010-12-20  Sandy Walsh <sandy.walsh@rackspace.com>, Trey Morris <trey.morris@rackspace.com>

	Adds support for Pause and Unpause of xenserver instances.
	
	Pause freezes the vm, keeping resources in-memory. 
	
	I used this version of python cloudservers to test with:
	https://github.com/SandyWalsh/python-cloudservers
	
	url's are
	http://a.b.c.d/v1.0/servers/#######/pause
	and
	http://a.b.c.d/v1.0/servers/#######/unpause
	
	Note: no support for libvirt.

2010-12-17  Jonathan Bryce <jbryce@jbryce.com>

	Removing unneeded Trial specific code

2010-12-17  Ed Leafe <ed@leafe.com>

	Replaced the use of redis in fakeldap with a customized dict class. Auth unittests should now run fine without a redis server running, or without python-redis installed.

2010-12-17  Jonathan Bryce <jbryce@jbryce.com>

	Adding Ed Leafe to Authors file

2010-12-16  Josh Kearney <josh.kearney@rackspace.com>

	Put flags back in nova.virt.xenapi/vm_utils.

2010-12-16  Andy Smith <code@term.ie>, termie <code@term.ie>

	This branch removes most of the dependencies on twisted and moves towards the plan described by https://blueprints.launchpad.net/nova/+spec/unified-service-architecture
	
	Tests are currently passing besides objectstore which is being skipped because it is heavily reliant on our twisted pieces, and I can run everything using the nova.sh
	
	Additionally this adds nova-combined that covers everythign except for nova-objectstore, to test it what I've usually done is run nova.sh as usual
	
	$ sudo ./eventlet_merge/contrib/nova.sh run ignored eventlet_merge
	
	and then quit all the services except for nova-objectstore and then in one of the screens do
	
	$ ./eventlet_merge/bin/nova-combined
	
	And then run whatever manual testing you normally run.
	
	Once objectstore has been deprecated and removed nova-combined can be expected to run the whole nova stack in a single process for testing and dev.

2010-12-15  Eldar Nugaev <enugaev@griddynamics.com>

	Fix 688220
	Added dependency on Twisted>=10.1.0 to pip-requires

2010-12-15  Soren Hansen <soren.hansen@rackspace.com>

	Make sure we properly close the bzr WorkingTree in our Authors up-to-datedness unit test.

2010-12-15  Vishvananda Ishaya <vishvananda@gmail.com>

	The ppa was moved.  This updates nova.sh to reflect that.

2010-12-14  jaypipes@gmail.com

	Initial work on i18n.  This adds the installation of the nova domain in gettext to all the "endpoints", which are all the bin/* files and run_tests.py.
	
	In addition, we place a small hack in /nova/tests/__init__.py that allows nosetests to run without problems.
	
	The next series of patches will "i18n"-ify the strings in Nova using the _() gettext function.

2010-12-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Includes architecture on register. Additionally removes a couple lines of cruft.

2010-12-13  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds support to the ec2 api for filtering describe volumes by volume_ids.

2010-12-13  Anne Gentle <anne@openstack.org>

	Added LiveCD info as well as some changes to reflect consolidation of .conf files.

2010-12-13  Chmouel Boudjnah <chmouel@chmouel.com>

	Fix exception throwing with wrong instance type.

2010-12-13  Devin Carlen <devin.carlen@gmail.com>

	Refactored smoketests to use novarc environment and to separate user and admin specific tests.

2010-12-13  Eric Day <eday@oddments.org>

	Changed OpenStack API auth layer to inject a RequestContext rather than building one everywhere we need it.

2010-12-09  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>, Josh Kearney <josh.kearney@rackspace.com>

	Make XenServer VM diagnostics available through nova.virt.xenapi.

2010-12-09  Sandy Walsh <sandy.walsh@rackspace.com>

	Flag to define which operations are exposed in the OpenStack API, disabling all others.

2010-12-09  Trey Morris <trey.morris@rackspace.com>

	some pylint caught changes to compute

2010-12-08  Andy Smith <code@term.ie>

	adds bzr to the list of dependencies in pip-require so that upon checkout using run_tests.sh succeeds

2010-12-08  Eric Day <eday@oddments.org>

	Finished cleaning up the openstack servers API, it no longer touches the database directly. Also cleaned up similar things in ec2 API and refactored a couple methods in nova.compute.api to accommodate this work.

2010-12-08  Eric Day <eday@oddments.org>, Michael Gundlach <michael.gundlach@rackspace.com>

	Pushed terminate instance and network manager/topic methods into network.compute.api.

2010-12-08  Eric Day <eday@oddments.org>

	Moved the reboot/rescue methods into nova.compute.api.

2010-12-08  Ryan Lane <rlane@wikimedia.org>

	This change adds better support for LDAP integration with pre-existing LDAP infrastructures. A new configuration option has been added to specify the LDAP driver should only modify/add/delete attributes for user entries.
	
	This change also fixes crashing issues for entries that have the novaUser objectclass, but do not have accessKey, secretKey, or isAdmin attributes. The code now only identifies a user as existing if all attributes and the objectclass exists.
	
	A couple new functions were added to check for existence of users in LDAP, even if they do not have the novaUser objectclass.
	
	The ldap_user_modify_only configuration option added assumes that users will be managed by external means, and will not attempt to add or delete user entries.

2010-12-07  Ryan Lane <rlane@wikimedia.org>

	Added a script to use OpenDJ as an LDAP server instead of OpenLDAP. Also modified nova.sh to add an USE_OPENDJ option, that will be checked when USE_LDAP is set.

2010-12-07  Soren Hansen <soren.hansen@rackspace.com>

	Make sure Authors check also works for pending merges (otherwise stuff can get merged that will make the next merge fail this check).

2010-12-07  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	It looks like Soren fixed the author file, can I hit the commit button?

2010-12-07  Soren Hansen <soren.hansen@rackspace.com>

	Add a helpful error message to nova-manage in case of NoMoreNetworks.
	
	This is one of the most common problems people have, and the solution
	is not currently easily discoverable. This should address that.

2010-12-07  Soren Hansen <soren.hansen@rackspace.com>

	Add Ryan Lucio to Authors.

2010-12-07  Ryan Lucio <rlucio@internap.com>

	Addresses bug 677475 by changing the DB column for internal_id in the instances table to be unsigned.

2010-12-03  Anne Gentle <anne@openstack.org>

	Fixes a missing step (nova-manage network create IP/nn n nn) in the single-node install guide

2010-12-03  Eric Day <eday@oddments.org>

	Tired of seeing various test files in bzr stat.

2010-12-02  Michael Gundlach <michael.gundlach@rackspace.com>

	Fix bugs that prevented OpenStack API from supporting server rename.

2010-12-02  Eric Day <eday@oddments.org>

	Consolidated the start instance logic in the two API classes into a single method. This also cleans up a number of small discrepencies between the two.

2010-12-02  Michael Gundlach <michael.gundlach@rackspace.com>

	Instances are assigned a display_name if one is not passed in -- and now, they're assigned a display_name even if None is explicitly passed in (as the EC2 API does.)
	
	And this time I gave in and wrote a test rather than relying on my super-awesome 'test-by-code-review' approach.

2010-12-01  Michael Gundlach <michael.gundlach@rackspace.com>

	Guarantee that the OpenStack API's Server-related responses will always contain a "name" value.  And get rid of a redundant field in models.py.

2010-12-01  Anne Gentle <anne@openstack.org>

	Adds in more documentation contributions from Citrix.

2010-12-01  Soren Hansen <soren.hansen@rackspace.com>

	Move cc_host and cc_port flags into nova/network/linux_net.py. They
	weren't used anywhere else.
	
	Make cc_host default to nova.utils.get_my_ip() instead of 127.0.0.1.
	cc_host is used to set up forwarding to the meta-data service, and the
	kernel doesn't allow routing to a loopback device, so 127.0.0.1 is a
	poor default.

2010-12-01  Soren Hansen <soren.hansen@rackspace.com>

	Add include_package_data=True to setup.py.
	
	This makes sure the various templates get installed into the python path when running "python setup.py install".

2010-12-01  Michael Gundlach <michael.gundlach@rackspace.com>

	With utils.default_flagfile() in its old location, the flagfile isn't being read -- twistd.serve() loads flags earlier than that point.  Move the utils.default_flagfile() call earlier so the flagfile is included.

2010-11-30  Michael Gundlach <michael.gundlach@rackspace.com>

	Delete unused flag in nova.sh.

2010-11-30  Ryan Lane <rlane@wikimedia.org>

	Moving the openldap schema out of nova.sh into it's own files, and adding sun (opends/opendj/sun directory server/fedora ds) schema files

2010-11-30  Michael Gundlach <michael.gundlach@rackspace.com>

	OpenStack API returns the wrong x-server-management-url.  Fix that.
	
	Fixes https://bugs.launchpad.net/nova/+bug/680709 .

2010-11-30  Soren Hansen <soren.hansen@rackspace.com>

	Fix DescribeImages EC2 API call.
	
	Reluctantly not including unit tests. I've filed bug #682888 about it. I think this is important enough to get fixed that we can defer the tests for a few days.

2010-11-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Default flagfile moved in trunk recently.  This updates nova.sh to run properly with the new flagfile location.

2010-11-29  Soren Hansen <soren.hansen@rackspace.com>

	Add a templating mechanism in the flag parsing.
	
	Add a state_path flag that will be used as the top-level dir for all other state (such as images, instances, buckets, networks, etc).
	This way you only need to change one flag to put all your state in e.g. /var/lib/nova. This simplifies packaging quite a bit.

2010-11-29  Michael Gundlach <michael.gundlach@rackspace.com>

	Rename cloudServersFault to computeFault -- I missed this Rackspace branding when we renamed nova.api.rackspace to nova.api.openstack.

2010-11-25  Vishvananda Ishaya <vishvananda@gmail.com>

	A few more changes:
	* Fixed up some flags
	* Put in an updated nova.sh
	* Broke out metadata forwarding so it will work in flatdhcp mode
	* Added descriptive docstrings explaining the networking modes in more detail
	
	Original Message:
	
	FlatDHCPManager wasn't quite working.  This makes it work again.  I discovered that automatically bridging into eth0 without a vlan is very dangerous.  If eth0 has an ip that you are using for ssh, you lose your connectivity.  For that reason, I set bridge_dev to None by default.  This unfortunately means that you have to specify a bridge_dev for VlanManager to actually work.

2010-11-24  Soren Hansen <soren.hansen@rackspace.com>

	Make sure all workers look for their flagfile in the same spot.
	
	Stop nova-manage from using /etc/nova/nova-manage.conf as its default
	flagfile. This made made development awkward since everything but
	nova-manage would use defaults for everything, but nova-manage would use
	whatever config was in /etc/nova/nova-manage.conf which was likely put
	there by a package of some sort.
	
	This way, we can leave it to the packagers to set this default to
	something else.

2010-11-24  Soren Hansen <soren.hansen@rackspace.com>

	Fix typo "nova.util" -> "nova.utils".

2010-11-24  Soren Hansen <soren.hansen@rackspace.com>, Anne Gentle <anne@openstack.org>

	Added a .mailmap that maps addresses in bzr to people's real, preferred
	e-mail addresses. (I made a few guesses along the way, feel free to
	adjust according to what is actually the preferred e-mail)
	
	Added a couple of methods to nova.utils to parse said .mailmap and do
	the appropriate (though highly na?ve) replacement.
	
	Apply mailmap replacement in changelog generation in setup.py.
	
	Add a unit test that checks everyone is properly listed in Authors.
	
	Add missing people to Authors.

2010-11-24  Soren Hansen <soren.hansen@rackspace.com>

	Add a placeholder in doc/build. Although bzr handles empty directories
	just fine, setuptools does not, so to actually ship this directory in
	the tarball, we need a file in it.

2010-11-23  Soren Hansen <soren.hansen@rackspace.com>

	doc/build was recently accidentally removed from VCS. This adds it back, which makes the docs build again.

2010-11-23  Josh Kearney <josh.kearney@rackspace.com>

	Make aws_access_key_id and aws_secret_access_key configurable.

2010-11-23  Anne Gentle <anne@openstack.org>

	Adding developer documentation - setting up dev environment and how to add to the OpenStack API

2010-11-23  Soren Hansen <soren.hansen@rackspace.com>

	Add a --logdir flag that will be prepended to the logfile setting. This makes it easier to share a flagfile between multiple workers while still having separate log files.

2010-11-23  Josh Kearney <josh.kearney@rackspace.com>

	Remove FAKE_subdomain from docs.

2010-11-23  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	No commit message
2010-11-22  Josh Kearney <josh.kearney@rackspace.com>

	Set and use AMQP retry interval and max retry FLAGS.

2010-11-22  Eric Day <eday@oddments.org>

	Allows user to specify hosts to listen on for nova-api and -objectstore

2010-11-22  Soren Hansen <soren.hansen@rackspace.com>

	Make sure all the libvirt templates are included in the tarball (by
	replacing the explicitly listed set with a glob pattern).

2010-11-22  Armando Migliaccio <Armando.Migliaccio@eu.citrix.com>

	fixed pep8 violations

2010-11-20  Josh Kearney <josh.kearney@rackspace.com>

	Check for running AMQP instances.

2010-11-19  Anne Gentle <anne@openstack.org>, Soren Hansen <soren.hansen@rackspace.com>

	Adds images (only links one in), start for a nova-manage man file, and also documents all nova-manage commands. Can we merge it in even though the man page build isn't working? 

2010-11-19  Eric Day <eday@oddments.org>

	Moves the EC2 API S3 image service into nova.service. There is still work to be done to make the APIs align, but this is the first step.

2010-11-18  Josh Kearney <josh.kearney@rackspace.com>

	Improved Pylint Score

2010-11-18  root <vishvananda@gmail.com>

	Fixes improper display of api error messages that happen to be unicode.

2010-11-17  Soren Hansen <soren.hansen@rackspace.com>

	Update version to 2011.1 as that is the version we expect to release next.

2010-11-17  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes eventlet race condition in cloud tests.

2010-11-17  Vishvananda Ishaya <vishvananda@gmail.com>

	ec2_api commands for describe_addresses and associate_address are broken in trunk.  This happened during the switch to ec2_id and internal_id.  We clearly didn't have any unit tests for this, so I've added a couple in addition to the three line change to actually fix the bugs.

2010-11-17  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds nova-debug to tools directory, for debugging of instances that lose networking.

2010-11-16  Ryan Lane <rlane@wikimedia.org>, Michael Gundlach <michael.gundlach@rackspace.com>

	Ryan_Lane's code to handle /etc/network not existing when we try to inject /etc/network/interfaces into an image.

2010-11-16  Todd Willey <todd@ansolabs.com>, root <sleepsonthefloor@gmail.com>, Vishvananda Ishaya <vishvananda@gmail.com>, Joe Heck <heckj@mac.com>, root <vishvananda@gmail.com>, Andy Smith <code@term.ie>, Anne Gentle <anne@openstack.org>, Dean Troyer <dtroyer@gmail.com>, Devin Carlen <devin.carlen@gmail.com>

	Lots of documentation and docstring updates.

2010-11-13  Joe Heck <heckj@mac.com>

	saw a duplicate import ... statement in the code while reading through unit tests - this removes the dupe.

2010-11-03  Eric Day <eday@oddments.org>

	Enables the exclusive flag for DirectConsumer queues.

2010-11-03  Vishvananda Ishaya <vishvananda@gmail.com>

	Ensures that keys for context from the queue are passed to the context constructor as strings.  This prevents hangs on older versions of python that can't handle unicode kwargs.

2010-11-03  Soren Hansen <soren.hansen@rackspace.com>

	Change socket type in nova.utils.get_my_ip() to SOCK_DGRAM. This way, we don't actually have to set up a connection.
	Also, change the destination host to an IP (chose one of Google's DNS's at random) rather than a hostname, so we avoid doing a DNS lookup.

2010-11-03  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes issue with security groups not being associated with instances.

2010-11-03  Eric Day <eday@oddments.org>

	Fix flags help display.

2010-11-03  Vishvananda Ishaya <vishvananda@gmail.com>

	ISCSI Volume support
	
	* Rewrite of Volume code to make VolumeManager more generic
	* AoE vs. ISCSI moved to driver layer
	* Added db support for target ids
	* Added code to re-export volumes on restart of VolumeManager
	* Includes a script to create /dev/iscsi volumes on remote hosts
	* Change libvirt_conn to use the python connection to attach disks instead of shell
	* Changed cloud and compute manager to deal with attaching, detaching, and terminating in
	a saner manner.

2010-11-02  Eric Day <eday@oddments.org>

	Adds support for multiple API ports, one for each API type (OS, EC2).

2010-10-29  Anne Gentle <anne@openstack.org>

	Add support for google analytics to only the hudson-produced docs.

2010-10-28  jaypipes@gmail.com

	Moves db writes into compute manager class. Cleans up sqlalchemy model/api to remove redundant calls for updating what is really a dict.

2010-10-26  Eric Day <eday@oddments.org>

	Fixes PEP8 violations from the last few merges.

2010-10-26  Anne Gentle <anne@openstack.org>

	Adding Google Analytics code to nova.openstack.org.

2010-10-26  Vishvananda Ishaya <vishvananda@gmail.com>, Michael Gundlach <michael.gundlach@rackspace.com>

	Fixes service unit tests after tornado excision.

2010-10-26  Vishvananda Ishaya <vishvananda@gmail.com>

	Removes some cruft from sqlalchemy/models.py like unused imports and the unused str_id method.

2010-10-26  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds rescue and unrescue commands.

2010-10-25  Jesse Andrews <anotherjesse@gmail.com>, Jesse Andrews <anotherjesse@gmail.com>

	validates device parameter for attach-volume

2010-10-25  Andy Smith <code@term.ie>

	Remove the last vestigial bits of tornado code still in use.
	
	An IP lawyer may want to comment on whether we need to assign copyright for the relavent 5 lines.

2010-10-25  Michael Gundlach <michael.gundlach@rackspace.com>

	Exceptions in the OpenStack API will be converted to Faults as they should be, rather than barfing a stack trace to the user.

2010-10-23  Eric Day <eday@oddments.org>

	Another pep8 cleanup branch for nova/tests, should be merged after lp:~eday/nova/pep8-fixes-other. After this, the pep8 violation count is 0!

2010-10-22  Vishvananda Ishaya <vishvananda@gmail.com>

	Changes block size for dd to a reasonable number.

2010-10-22  Eric Day <eday@oddments.org>

	Another pep8 cleanup branch for nova/api, should be merged after lp:~eday/nova/pep8-fixes.

2010-10-22  Rick Clark <rick@openstack.org>

	Created Authors file.

2010-10-21  Anne Gentle <anne@openstack.org>

	Cleanup of doc for dependencies (redis optional, remove tornado, etc). Please check for accuracy.

2010-10-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Delays the creation of the looping calls that that check the queue until startService is called.

2010-10-20  Todd Willey <todd@ansolabs.com>

	Authorize image access instead of just blindly giving it away.

2010-10-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Checks the pid of dnsmasq to make sure it is actually referring to the right process.

2010-10-20  Rick Clark <rick@openstack.org>

	change boto version from 1.9b1 to 1.9b in pip-requires

2010-10-20  Soren Hansen <soren.hansen@rackspace.com>

	Update version set in setup.py to 2010.1 in preparation for Austin release.

2010-10-20  jaypipes@gmail.com

	* Fills out the Parallax/Glance API calls for update/create/delete and adds unit tests for them.
	* Modifies the ImageController and GlanceImageService/LocalImageService calls to use index and detail routes to comply perfectly with the RS/OpenStack API.

2010-10-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes disk.partition resize root drive to 10G, unless it is m1.tiny which just leaves it as is.  Larger images are just used as is.

2010-10-20  Rick Clark <rick@openstack.org>

	reverted python-boto version in pip-requires to 1.9b1.

2010-10-19  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds reasonable default local storage gb to instance sizes.

2010-10-19  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes nova-dhcpbridge notify nova-network on old network lease updates.

2010-10-16  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds a simple nova-manage command called scrub to deallocate the network and remove security groups for a projeect.

2010-10-16  Soren Hansen <soren.hansen@rackspace.com>

	Refresh MANIFEST.in to make the tarball include all the stuff that belongs in the tarball.

2010-10-16  Eric Day <eday@oddments.org>

	Added test case to reproduce bug #660668 and provided a fix by using the user_id from the auth layer instead of the username header.

2010-10-15  Soren Hansen <soren.hansen@rackspace.com>

	Fix two problems with get_console_log:
	* libvirt has this annoying "feature" where it chown()s your console to the uid running libvirt. That gets in the way of reading it. Add a call to "sudo chown ...." right before we read it to make sure it works out well.
	* We were looking in the wrong directory for console.log. *blush*

2010-10-15  Vishvananda Ishaya <vishvananda@gmail.com>

	This branch converts incoming data to the api into the proper type.

2010-10-15  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes deprecated use of context in nova-manage network create.

2010-10-15  Andy Smith <code@term.ie>

	Fix the --help flag for printing help on twistd-based services

2010-10-15  Eric Day <eday@oddments.org>

	Fix for bug 660818 by adding the resource ID argument.

2010-10-15  Soren Hansen <soren.hansen@rackspace.com>

	Fix some unit tests:
	* One is a race due to the polling nature of rpc in eventlet based unit tests.
	* The other is a more real problem. It was caused by datastore.py being removed. It wasn't caught earlier because the .pyc file was still around on the tarmac box.

2010-10-15  Soren Hansen <soren.hansen@rackspace.com>

	Make Redis completely optional:
	
	* Move Redis code into fakeldap, since it's the only thing that still uses it.
	* Adjust auth unittests to skip fakeldap tests if Redis isn't around.
	* Adjust auth unittests to actually run the fakeldap tests if Redis /is/ around.

2010-10-15  Andy Smith <code@term.ie>

	run_tests.sh presents a prompt:
	
	No virtual environment found...create one? (Y/n)
	
	However hitting enter to select the default (Y) actually selects 'n', this patch fixes that.
	
	In all reality this should probably be slightly smarter and not accept invalid input as invalid input will mean "no" and probably result in an unexpected error depending on what the user has installed, but for now it will at least do what is expected in the "happy" case.

2010-10-15  Vishvananda Ishaya <vishvananda@gmail.com>

	A few more fixes for deprecations.

2010-10-14  Vishvananda Ishaya <vishvananda@gmail.com>

	This branch modifies the fixes all of the deprecation warnings about empty context.  It does this by adding the following fixes/features
	* promotes api/context.py to context.py because it is used by the whole system
	* adds more information to the context object
	* passes the context through rpc
	* adds a helper method for promoting to admin context (elevate())
	* modifies most checks to use context.project_id instead of context.project.id to avoid
	trips to the database
	
	This included a lot of merge fixing and backporting from the anso deploy branch so some stuff may be broken.  Right now it throws an Exception('die') in addition to the deprecation warning so we get a stack trace and can find any other deprecated calls.  This needs some testing, especially of the openstack api.

2010-10-14  jaypipes@gmail.com

	Fixes LP Bug#660095.

2010-10-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes a few concurrency issues with creating volumes and instances. Most importantly it adds retries to a number of the volume shell commands and it adds a unique constraint on export_devices and a safe create so that there aren't multiple copies of export devices in the database.

2010-10-14  Michael Gundlach <michael.gundlach@rackspace.com>

	Fixes bug 660115.
	
	Part of the cause of the confusion that led to this problem is I think that we have 3 different 'user' objects that can be passed to different methods: a simple dict, an auth.User object, and a db.sqlalchemy.models.User object (which maps __getitem__ to getattr for good measure.)  When we sweep through and add clear docstrings to every method, explaining their inputs and outputs, I think errors like these will be less likely.

2010-10-13  Soren Hansen <soren.hansen@rackspace.com>

	Xen support.

2010-10-13  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds flat networking + dhcpserver mode.

2010-10-13  Vishvananda Ishaya <vishvananda@gmail.com>

	This patch removes the ugly network_index that is used by VlanManager and turns network itself into a pool.  It adds support for creating the networks through an api command:
	nova-manage network create # creates all of the networks defined by flags
	or
	nova-manage network create 5 # create the first five networks
	
	This moves the network out of project.create, associating a network to a project lazily in project_get_network.  This allows for a bit greater control over networks.  There are a couple outstanding issues:
	1) Where do networks get disassociated?  Right now I'm not disassociating at all.  We're sharing ldap users across different deploys, whereas sql db is unique per deploy.  Perhaps the solution is to have a flag like disassociate_on_project_destroy and make it optional?
	2) How do we handle creation of networks for tests?  It is really slow to create a pool of networks and fixed_ips for each test case.  Right now I'm taking advantage of the fact that the db isn't cleaned between tests, and creating them if they don't exist in BaseTestCase.SetUp() and disassociating in TearDown().  Ideally this should be replaced with fixtures of some sort.
	
	Comments on these two issues are welcome.

2010-10-12  Michael Gundlach <michael.gundlach@rackspace.com>

	Revert the conversion to 64-bit ints stored in a PickleType column, because PickleType is incompatible with having a unique constraint.
	
	We moved away from 32 bit ints because of the chance of collision.  It turns out the existing code already checked for collisions and retried, so this wasn't an issue.

2010-10-12  Soren Hansen <soren.hansen@rackspace.com>, Vishvananda Ishaya <vishvananda@gmail.com>, Devin Carlen <devin.carlen@gmail.com>

	This patch adds support for EC2 security groups using libvirt's nwfilter mechanism, which in turn uses iptables and ebtables on the individual compute nodes.
	This has a number of benefits:
	* Inter-VM network traffic can take the fastest route through the network without our having to worry about getting it through a central firewall.
	* Not relying on a central firewall also removes a potential SPOF.
	* The filtering load is distributed, offering great scalability.
	
	Caveats:
	* It only works with libvirt and only with libvirt drivers that support nwfilter (qemu (and thus kvm) and uml, at the moment)

2010-10-12  Michael Gundlach <michael.gundlach@rackspace.com>

	Change internal_id from a 32 bit int to a 64 bit int.
	
	Specifically, generate internal_id as a random number in [0, 2^64).  SQLAlchemy has no built-in type for big integers, so the internal_id column is a PickleType, set to non-mutable to avoid performance penalties associated with mutable column types.  Under the hood, this is stored as a Binary.
	
	In Austin+1 we'll probably be replacing internal_id with a string, but we need something bigger than 32 bits for Austin.

2010-10-12  Michael Gundlach <michael.gundlach@rackspace.com>

	Make Instance.name a string again instead of an integer.
	
	Prefix it with some characters for good measure in case any code consumes .name and can't handle strings of the form /[0-9]+/.

2010-10-12  Ewan Mellor <ewan.mellor@citrix.com>

	Catch exception.NotFound when getting project VPN data.

2010-10-12  Soren Hansen <soren.hansen@rackspace.com>

	Improve the virt unit tests.

2010-10-11  Michael Gundlach <michael.gundlach@rackspace.com>

	Rename ec2_id_list back to instance_id to conform to EC2 argument spec

2010-10-11  Michael Gundlach <michael.gundlach@rackspace.com>

	Fix bug 657001 (rename all Rackspace references to OpenStack references)

2010-10-11  Soren Hansen <soren.hansen@rackspace.com>

	Extracts the kernel and ramdisk id from manifests and puts in into images' metadata.

2010-10-11  Soren Hansen <soren.hansen@rackspace.com>

	Fix EC2 GetConsoleOutput method and add unit tests for it.

2010-10-11  jaypipes@gmail.com

	Adds --force option to run_tests.sh to clear virtualenv. Useful when dependencies change

2010-10-08  mdietz <matt.dietz@rackspace.com>

	Renames every instance of "rackspace" in the API and test code base. Also includes a minor patch for the API Servers controller to use images correctly in the absence of Glance. 

2010-10-08  Michael Gundlach <michael.gundlach@rackspace.com>

	Remove redis dependency from RS Images API.

2010-10-07  Hisaki Ohara <hisaki.ohara@intel.com>

	Since FLAGS.images_path was not set for nova-compute, I could not launch instances
	due to an exception at _fetch_local_image() trying to access to it.
	I think that this is the reason of Bug655217.
	
	I'm not sure whether it is global solution, because FLAGS.images_path is defined
	in nova/objectstore/image.py too.

2010-10-05  mdietz <matt.dietz@rackspace.com>

	Cleans up a broken servers unit test

2010-10-05  jaypipes@gmail.com

	Adds stubs and tests for GlanceImageService and LocalImageService.
	Adds basic plumbing for ParallaxClient and TellerClient and hooks that into the GlanceImageService.
	
	Fixes lp654843

2010-10-05  Michael Gundlach <michael.gundlach@rackspace.com>

	Typo

2010-10-05  mdietz <matt.dietz@rackspace.com>, Cerberus <matt.dietz@rackspace.com>

	Cleanup around the rackspace API for the ec2 to internal_id transition

2010-10-05  Michael Gundlach <michael.gundlach@rackspace.com>

	Replace model.Instance.ec2_id with an integer internal_id so that both APIs can represent the ID to external users.

2010-10-05  Todd Willey <todd@ansolabs.com>

	Keep handles to loggers open after daemonizing.

2010-10-04  jaypipes@gmail.com

	Cleans up the unit tests that are meant to be run with nosetests
	
	* Renames all test modules to start with test_ so that nosetests does
	not need to be run with the --all-modules flag in order to pick them up
	* Renames test_helper to fakes and removes imports in unit tests that
	did not reference the fakes
	* Adds nose to pip-requires so that run_tests.sh -V will install nose
	into the virtualenv instead of having to manually install it after running
	into import errors :)

2010-10-04  Ewan Mellor <ewan.mellor@citrix.com>

	Matches changes in the database / model layer with corresponding fixes to nova.virt.xenapi.

2010-10-04  Soren Hansen <soren.hansen@rackspace.com>

	A shiny, new Auth driver backed by SQLAlchemy. Read it and weep. I did.

2010-10-04  Soren Hansen <soren.hansen@rackspace.com>

	Move manager_class instantiation and db.service_* calls out of nova.service.Service.__init__ into a new  nova.service.Service.startService method which gets called by twisted. This delays opening db connections (and thus sqlite file creation) until after privileges have been shed by twisted.

2010-10-04  Ewan Mellor <ewan.mellor@citrix.com>

	Add a context of None to the call to db.instance_get_all.

2010-10-04  Ewan Mellor <ewan.mellor@citrix.com>

	Honour the --verbose flag by setting the logging level to DEBUG.

2010-10-04  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #653560: AttributeError in VlanManager.periodic_tasks
	
	Pass the correct context to db.fixed_ip_disassociate_all_by_timeout.

2010-10-03  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #653534: NameError on session_get in sqlalchemy.api.service_update
	
	Fix function call: session_get was meant to be service_get.

2010-10-03  Soren Hansen <soren.hansen@rackspace.com>

	Fixes to address the following issues:
	
	* nova-network no longer refrains from configuring bridges if it finds them already created. This solves a race condition with nova-network and nova-compute running on the same box. If nova-compute happened to do its network config first, nova-network would find the bridge already created and assume it was correctly setup. If nova-network got there first, it would apply the correct IP configuration to the interface. The assumption is that no harm will be done by reapplying the correct IP configuration, so we no longer make this check before doing so.
	
	* nova-network does not use persistent network configuration (like putting stuff in /etc/network/interfaces), so it needs to check at boot time whether it's already set as a network's designated network node and do the appropriate configuration.
	
	* If installed, dnsmasq wouldn't find nova-dhcpbridge properly (it would look for it in /usr/lib/python2.6/blahblahblha). Add a flag to specify its location (and make use of it in the packaging).
	
	* dnsmasq needs to be able to read the dhcp config written by nova. dnsmasq runs as user "nobody", so chmod 644 the config file so that it can be read.
	
	* dnsmasq needs to be sent a SIGHUP to reread its config. Wrap this call in sudo, because we may be running as non-root.

2010-10-01  Devin Carlen <devin.carlen@gmail.com>

	Refactor sqlalchemy api to perform contextual authorization.
	
	All database calls now examine the context object for information about what kind of user is accessing the data.  If an administrator is accessing, full privileges are granted.  If a normal user is accessing, then checks are made to ensure that the user does indeed have the rights to the data.
	
	Also refactored NovaBase and removed several methods since they would have to be changed when we move away from sqlalchemy models and begin using sqlalchemy table definitions.

2010-10-01  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds support for periodic_tasks on manager that are regularly called by the service and recovers fixed_ips that didn't get disassociated properly.

2010-10-01  Cerberus <matt.dietz@rackspace.com>

	Includes changes for creating instances via the Rackspace API. Utilizes much of the existing EC2 functionality to power the Rackspace side of things, at least for now. 

2010-09-30  Todd Willey <todd@ansolabs.com>

	Get rid of mention of mongo, since we are using openstack/swift.

2010-09-30  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #652103: NameError in exception handler in sqlalchemy API layer
	
	Fix reference to NoResultFound.

2010-09-30  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #651887: xenapi list_instances completely broken
	
	Don't just compute the result for list_instances -- return it!

2010-09-29  Michael Gundlach <michael.gundlach@rackspace.com>

	Make Fault raiseable, and add a test to verify that.

2010-09-29  Todd Willey <todd@ansolabs.com>

	Related: https://code.launchpad.net/~anso/nova/authupdate/+merge/36925

2010-09-29  Michael Gundlach <michael.gundlach@rackspace.com>

	Support the pagination interface in RS API -- the &offset and &limit parameters are now recognized.
	
	This implementation is stupid (it just slices the full list at the last second), so in Bexar we should do this right.

2010-09-29  Michael Gundlach <michael.gundlach@rackspace.com>

	Support fault notation in error messages in the RS API.

2010-09-29  Todd Willey <todd@ansolabs.com>

	Add user-editable name & notes/description to volumes, instances, and images.

2010-09-29  Todd Willey <todd@ansolabs.com>

	* Create an AuthManager#update_user method to change keys and admin status.
	* Refactor the auth_unittest to not care about test order
	* Expose the update_user method via nova-manage

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Updates the fix-iptables branch with a number of bugfixes.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes reversed arguments in nova-manage project environment.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes sure that multiple copies of nova-network don't create multiple copies of the same NetworkIndex.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix a few errors in api calls related to mistyped database methods for floating_ips: specifically describe addresses and and associate address.

2010-09-29  Eric Day <eday@oddments.org>

	Merged Termie's branch that starts tornado removal and fixed rpc test cases for twisted. Nothing is testing the Eventlet version of rpc.call though yet.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds bpython support to nova-manage shell, because it is super sexy.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds a disabled flag to service model and check for it when scheduling instances and volumes.

2010-09-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds bpython support to nova-manage shell, because it is super sexy.

2010-09-29  Devin Carlen <devin.carlen@gmail.com>

	Added random ec2 style id's for volumes and instances.

2010-09-28  Cerberus <matt.dietz@rackspace.com>

	Implementation of the Rackspace servers API controller
	
	Currently, work remains on the controller, but I'm proposing a merge before the diff becomes completely unwieldy. However, all implemented tests pass. 

2010-09-28  Devin Carlen <devin.carlen@gmail.com>

	Refactored adminclient to support multiple regions

2010-09-28  Soren Hansen <soren.hansen@rackspace.com>

	Stop trying to install nova-api-new (it's gone).
	Install nova-scheduler.

2010-09-23  Michael Gundlach <michael.gundlach@rackspace.com>

	Put EC2 API -> eventlet back into trunk, fixing the bits that I missed when I put it into trunk on 9/21.
	
	Note that some of this got into trunk via r291 accidentally because r291 was a branch based off of the trunk that was reverted on 9/22.

2010-09-23  mdietz <matt.dietz@rackspace.com>

	Implementation of Rackspace token based authentication for the Openstack API. 
	
	This is a re-proposal of a merge earlier that was failing to merge no matter what I tried, so this is the next option in a series of failures. All tests pass locally. 

2010-09-23  Soren Hansen <soren.hansen@rackspace.com>

	When calculating timedeltas make sure both timestamps are in UTC.
	For people ahead of UTC, it makes the scheduler unit tests pass.
	For people behind UTC, it makes their services time out after 60 seconds without a heart beat rather than X hours and 60 seconds without a heart beat (where X is the number of hours they're behind UTC).

2010-09-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Implements quotas with overrides for instances, volumes, and floating ips.

2010-09-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Moves keypairs out of ldap and into the common datastore.

2010-09-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes server error on get metadata when instances are started without keypairs.

2010-09-21  Todd Willey <todd@ansolabs.com>

	allows api servers to have a list of regions, allowing multi-cluster support if you have a shared image store and user database.

2010-09-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Added modify project command to auth manager to allow changing of project manager and description.

2010-09-20  Michael Gundlach <michael.gundlach@rackspace.com>

	Support querying version list, per the RS API spec.  Fixes bug 613117.

2010-09-20  Michael Gundlach <michael.gundlach@rackspace.com>

	Add a RateLimitingMiddleware to the Rackspace API, implementing the rate limits as defined by the current Cloud Servers spec.  The Middleware can do rate counting in memory, or (for deployments that have more than one API Server) can offload to a rate limiting service.
	
	Also adds a:
	- Limiter (basic rate counting object)
	- WSGIApp (serving up a Limiter behind a standalone RESTful application)
	- WSGIAppProxy (drop-in replacement for a Limiter which the Middleware uses when configured to offload to a service)
	
	Note that the nova.api.rackspace.ratelimiting package will be moved to PyPI after Austin, which is why it contains tests in its own directory instead of in nova.tests.  We added the ratelimiting package directly into OpenStack for expediency with the approaching Austin deadline.

2010-09-20  Monty Taylor <mordred@inaugust.com>

	A small fix to the install_venv program to allow us to run it on the tarmac box as part of the tarmac build.

2010-09-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Removes second copy of ProcessExecutionError that creeped in during a bad merge.

2010-09-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds an omitted yield in compute manager detach_volume.

2010-09-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds timing fields to instances and volumes to track launch times and schedule times.

2010-09-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes two errors in cloud.py in the nova_orm branch:
	a) self.network is actually called network_manager
	b) the logic for describe-instances check on is_admin was reversed

2010-09-20  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds timing fields to instances and volumes to track launch times and schedule times.

2010-09-16  Vishvananda Ishaya <vishvananda@gmail.com>

	Better error message on the failure of a spawned process, and it's a ProcessExecutionException irrespective of how the process is run (twisted or not)

2010-09-15  Vishvananda Ishaya <vishvananda@gmail.com>

	Proposing merge to get feedback on orm refactoring.  I am very interested in feedback to all of these changes.
	
	This is a huge set of changes, that touches almost all of the files.  I'm sure I have broken quite a bit, but better to take the plunge now than to postpone this until later.  The idea is to allow for pluggable backends throughout the code.
	
	Brief Overview
	For compute/volume/network, there are multiple classes
	service - responsible for rpc
	this currently uses the existing cast and call in rpc.py and a little bit of magic
	to call public methods on the manager class.
	each service also reports its state into the database every 10 seconds
	manager - responsible for managing respective object classes
	all the business logic for the classes go here
	db (db_driver) - responsible for abstracting database access
	driver (domain_driver) - responsible for executing actual shell commands and implementation
	
	Compute hasn't been fully cleaned up, but to get an idea of how it works, take a look
	at volume and network
	
	Known issues/Things to be done:
	
	* nova-api accesses db objects directly
	It seems cleaner to have only the managers dealing with their respective objects.  This would
	mean code for 'run_instances' would move into the manager class and it would do the initial
	setup and cast out to the remote service
	
	* db code uses flat methods to define its interface
	In my mind this is a little prettier as an abstract base class, but driver loading code
	can load a module or a class.  It works, so I'm not sure it needs to be changed but feel
	free to debate it.
	
	* Service classes have no code in them
	Not sure if this is a problem for people, but the magic of calling the manager's methods is
	done in the base class.  We could remove the magic from the base class and explicitly
	wrap methods that we want to make available via rpc if this seems nasty.
	
	* AuthManager Projects/Users/Roles are not integrated into this system.
	In order for everything to live happily in the backend, we need some type
	of adaptor for LDAP
	
	* Context is not passed properly across rabbit
	Context should probably be changed to a simple dictionary so that it can be
	passed properly through the queue
	
	* No authorization checks on access to objects
	We need to decide on which layer auth checks should happen.
	
	* Some of the methods in ComputeManager need to be moved into other layers/managers
	* Compute driver layer should be abstracted more cleanly
	* Flat networking is untested and may need to be reworked
	* Some of the api commands are not working yet
	* Nova Swift Authentication needs to be refactored(Todd is working on this)

2010-09-14  Ewan Mellor <ewan.mellor@citrix.com>

	When destroying a VM using the XenAPI backend, if the VM is still running (the usual case) the destroy fails. It needs to be powered-off first.

2010-09-14  Ewan Mellor <ewan.mellor@citrix.com>

	Remove power state constants that have ended up duplicated following a bad
	merge. They were moved from nova.compute.node.Instance into
	nova.compute.power_state at the same time that Instance was moved into
	nova.compute.service. We've ended up with these constants in both places.
	
	Remove the ones from service, in favour of the ones in power_state.

2010-09-13  Soren Hansen <soren.hansen@rackspace.com>

	Move vol.destroy() call out of the _check method in test_multiple_volume_race_condition test and into a callback of the DeferredList. This should fix the intermittent failure of that test. I /think/ test_too_many_volumes's failure was caused by test_multiple_volume_race_condition failure, since I have not been able to reproduce its failure after fixing this one.

2010-09-13  Jesse Andrews <anotherjesse@gmail.com>

	Adds 'shell run' to nova manage, which spawns a shell with flags properly imported.

2010-09-08  Soren Hansen <soren.hansen@rackspace.com>

	It's annoying and confusing to have to set PYTHONPATH to point to your
	development tree before you run any of the scripts.
	
	If you're lucky, it just fails (because you don't have nova in the default
	search path (i.e.  don't have them installed in /usr/lib/blah)) so that you can
	fix it up.
	
	If you're less lucky, you spend at least a couple of minutes wondering
	why the cool changes you made to one of the nova modules don't take effect
	until you realise it's because it's using the nova stuff in /usr/lib.
	
	So, to save myself (and probably others) a bit of time, this patch adds
	a snippet to each of the scripts in bin/ to detect this and set up the PYTHONPATH. 

2010-09-03  Soren Hansen <soren.hansen@rackspace.com>

	Just a couple of UML-only fixes:
	* Due to an issue with libvirt, we need to chown the disk image to root.
	* Just point UML's console directly at a file, and don't bother with the pty. It was only used for debugging.

2010-09-02  Michael Gundlach <michael.gundlach@rackspace.com>

	Replace an if/else with a dict lookup to a factory method.

2010-09-01  Soren Hansen <soren.hansen@rackspace.com>

	Create console.log ahead of time. This ensures that the user running nova-compute maintains read privileges.

2010-09-01  Soren Hansen <soren.hansen@rackspace.com>

	This improves the changelog generated as part of "setup.py sdist". If you look at it now, it says that Tarmac has done everything and every little commit is listed. With this patch, it only logs the "top-most" commit and credits the author rather than the committer.
	
	Example from the current output format (from current trunk):
	##########################################
	2010-08-31  Tarmac
	
	Adjust setup.py to match nova-rsapi -> nova-api-new rename.
	
	2010-08-31  Soren Hansen  <soren.hansen@rackspace.com>
	
	Fix up setup.py to match nova-rsapi -> nova-api-new rename.
	
	2010-08-30  Tarmac
	
	Reconnect to libvirt on broken connection.
	
	2010-08-30  Soren Hansen  <soren.hansen@rackspace.com>
	
	Detect if libvirt connection has been broken and reestablish it.
	
	2010-08-30  Tarmac
	
	pylint fixes for /nova/virt/connection.py
	
	2010-08-30  jaypipes@gmail.com
	
	Merge trunk and resolve conflicts
	
	##########################################
	
	
	
	With this patch, this is reduced to:
	
	
	##########################################
	2010-08-31  Soren Hansen <soren.hansen@rackspace.com>
	
	Adjust setup.py to match nova-rsapi -> nova-api-new rename.
	
	2010-08-30  Soren Hansen <soren.hansen@rackspace.com>
	
	Reconnect to libvirt on broken connection.
	
	2010-08-30  jaypipes@gmail.com
	
	pylint fixes for /nova/virt/connection.py
	
	##########################################

2010-09-01  Cerberus <matt.dietz@rackspace.com>

	Moved API tests into a sub-folder of the tests/ and added a stubbed-out test declarations to mirror existing API tickets. 
	
	Resubmission from earlier because of my improper file move. 

2010-08-31  Soren Hansen <soren.hansen@rackspace.com>

	Call getInfo() instead of getVersion() on the libvirt connection object. virConnectGetVersion was not exposed properly in the python bindings until quite recently, so this makes us rather more backwards compatible.

2010-08-31  Soren Hansen <soren.hansen@rackspace.com>

	Adjust setup.py to match nova-rsapi -> nova-api-new rename.

2010-08-30  Soren Hansen <soren.hansen@rackspace.com>

	Reconnect to libvirt on broken connection.

2010-08-30  jaypipes@gmail.com

	pylint fixes for /nova/virt/connection.py

2010-08-30  jaypipes@gmail.com

	pylint fixes for nova/objectstore/handler.py

2010-08-30  Michael Gundlach <michael.gundlach@rackspace.com>

	Add Flavors controller supporting
	
	GET /flavors
	
	GET /flavors/detail
	
	GET /flavors/<id>
	
	Also add GET /images/detail
	
	Turn the RackspaceAPIImageIdTranslator into a RackspaceAPIIdTranslator, so that it can be used to translate IDs for other rackspace API components as well (servers, backup schedules.)  I thought I'd need it for flavors but it turns out flavors are so simple I could hard code their ids into compute.instance_types.INSTANCE_TYPES.

2010-08-30  Eric Day <eday@oddments.org>

	Dead code removal.

2010-08-25  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes issue with the same ip being assigned to multiple instances.

2010-08-25  Michael Gundlach <michael.gundlach@rackspace.com>

	Initial support for Rackspace API /image requests.  They will eventually be backed by Glance.
	
	Because we don't expect Glance to support non-public images for the Austin release, all we support is index() and show().
	
	The WSGI controller uses a service to interact with the image store (the "ImageService").  Eventually it will use a GlanceImageService, but since Glance isn't implemented yet it's hard coded to use a LocalImageService for testing.
	
	The ImageService maps URIs to image data (because Glance will be the canonical backend and that's how Glance does it), but the Rackspace API maps ids to image data.  So the images.Controller stores a mapping in the global Redis service to convert from URIs to ids.
	
	Courtesy of whatthecommit.com:
	
	(\ /)
	(O.o)
	(> <) Bunny approves these changes.

2010-08-25  Michael Gundlach <michael.gundlach@rackspace.com>

	Fix a pep8 violation.

2010-08-24  Soren Hansen <soren.hansen@rackspace.com>

	Ensure that --gid and --uid options work for both twisted and non-twisted daemons.

2010-08-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes an error in setup_compute_network that was causing network setup to fail.

2010-08-24  Ewan Mellor <ewan.mellor@citrix.com>

	Rework virt.xenapi's concurrency model.  There were many places where we were
	inadvertently blocking the reactor thread.  The reworking puts all calls to
	XenAPI on background threads, so that they won't block the reactor thread.
	
	Long-lived operations (VM start, reboot, etc) are invoked asynchronously
	at the XenAPI level (Async.VM.start, etc).  These return a XenAPI task.  We
	relinquish the background thread at this point, so as not to hold threads in
	the pool for too long, and use reactor.callLater to poll the task.
	
	This combination of techniques means that we don't block the reactor thread at
	all, and at the same time we don't hold lots of threads waiting for
	long-running operations.
	
	There is a FIXME in here: get_info does not conform to these new rules.
	Changes are required in compute.service before we can make get_info
	non-blocking.

2010-08-20  Justin Santa Barbara <justin@fathomdb.com>

	Check exit codes when spawning processes by default
	Also pass --fail to curl so that it sets exit code when download fails

2010-08-20  Eric Day <eday@oddments.org>

	PEP8/pylint cleanup in bin and nova/auth.

2010-08-19  Eric Day <eday@oddments.org>

	Added unit tests for WSGI helpers and base WSGI API.

2010-08-18  Eric Day <eday@oddments.org>

	First in a series of patches to port the API from Tornado to WSGI. Also includes a few small style fixes in the new API code.

2010-08-18  Michael Gundlach <michael.gundlach@rackspace.com>

	Since pylint=0.19 is our version, force everyone to use the disable-msg syntax.

2010-08-17  jaypipes@gmail.com

	No longer installs a virtualenv automatically and adds new options to bypass the interactive prompt.

2010-08-17  Ewan Mellor <ewan.mellor@citrix.com>

	Add documentation to spawn, reboot, and destroy stating that those functions
	should return Deferreds.  Update the fake implementations to do so (the
	libvirt ones already do, and making the xenapi ones do so is the subject of
	a current merge request).

2010-08-17  Michael Gundlach <michael.gundlach@rackspace.com>

	See description of change... what's the difference between that message and this message again?

2010-08-17  Michael Gundlach <michael.gundlach@rackspace.com>

	The file that I create automates this step in http://wiki.openstack.org/InstallationNova20100729 :
	
	# is there an easier way to do this? automation? Relative paths?
	echo "/path/to/bzr/branch" > /path/to/bzr/branch/.nova-venv/lib/python2.6/site-packages/nova.pth

2010-08-17  andy <code@term.ie>

	Fixes quite a few style issues across the entire nova codebase bringing it much closer to the guide described in HACKING.

2010-08-16  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes issues with allocation and deallocation of fixed and elastic addresses.

2010-08-16  Ewan Mellor <ewan.mellor@citrix.com>

	Added documentation for the nova.virt connection interface, a note about the need to chmod the objectstore script, and a reference for the XenAPI module.

2010-08-16  Ewan Mellor <ewan.mellor@citrix.com>

	improve compatibility with ec2 clients

2010-08-16  Soren Hansen <soren.hansen@rackspace.com>

	Add new libvirt_type option "uml" for user-mode-linux.. This switches the libvirt URI to uml:///system and uses a different template for the libvirt xml.

2010-08-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Catches and logs exceptions for rpc calls and raises a RemoteError exception on the caller side.

2010-08-14  Joel Moore joelbm24@gmail.com

	Removes requirement of internet connectivity to run api server.

2010-08-14  Joel Moore joelbm24@gmail.com

	Fixed path to keys directory.

2010-08-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Removes the workaround for syslog-ng of removing newlines.

2010-08-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes bug lp:616312 by reversing the order of args in nova-manage when it calls AuthManager.get_credentials.

2010-08-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Sets a hostname for instances that properly resolves and cleans up network classes

2010-08-14  Devin Carlen <devin.carlen@gmail.com>

	Implemented admin client / admin api for fetching user roles.

2010-08-14  Vishvananda Ishaya <vishvananda@gmail.com>

	Improves pep8 compliance and pylint score in network code.

2010-08-14  Ewan Mellor <ewan.mellor@citrix.com>

	Bug #617776: DescribeImagesResponse contains type element, when it should be called imageType
	
	Make the objectstore respond with the field 'imageType' as well as 'type'.
	The former is the correct one, according to the EC2 API specification for
	the DescribeImages response.  The latter is for compatibility with euca2ools
	and other clients.

2010-08-12  Ewan Mellor <ewan.mellor@citrix.com>

	Implement the same fix as lp:~vishvananda/nova/fix-curl-project, but for virt.xenapi.

2010-08-12  Ewan Mellor <ewan.mellor@citrix.com>

	Fix exception in get_info.

2010-08-11  Ewan Mellor <ewan.mellor@citrix.com>

	Added a xapi plugin that can pull images from nova-objectstore, and use that
	to get a disk, kernel, and ramdisk for the VM.

2010-08-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Improved roles functionality (listing & improved test coverage)

2010-08-11  Michael Gundlach <michael.gundlach@rackspace.com>

	updated virtualenv to add eventlet, which is now a requirement

2010-08-11  jaypipes@gmail.com

	Changes the run_tests.sh and /tools/install_venv.py scripts to be
	more user-friendly and not depend on PIP while not in the virtual
	environment.

2010-08-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes bug lp:615857 by changing the name of the zip export method in nova-manage

2010-08-10  Ewan Mellor <ewan.mellor@citrix.com>

	Implement VIF creation in the xenapi module.

2010-08-10  Joe Heck <heckj@mac.com>

	2 changes in doing PEP8 & Pylint cleaning:
	* adding pep8 and pylint to the PIP requirements files for Tools
	* light cleaning work (mostly formatting) on nova/endpoints/cloud.py
	
	Note: On my laptop, I had two tests failing just with a basic setup. I checked against all the tests again after cleanup, and had no additional or different failures.

2010-08-10  Vishvananda Ishaya <vishvananda@gmail.com>

	More changes to volume to fix concurrency issues.  Also testing updates.
	
	volumes now store a set of available shelf/blades in the datastore, instead of depending on a filesystem glob.  This avoids a race condition that occurs where two different volumes are attempting to export to the same location.
	
	The general idea of pooled resources needs to be abstracted out into the datamodel.  It is used for vpn ports and volumes now, and should be uses for ip addresses as well.

2010-08-10  Michael Gundlach <michael.gundlach@rackspace.com>

	Merge.

2010-08-10  andy <code@term.ie>

	Add some useful features to our flags
	
	* No longer dies if there are unknown flags.
	* Allows you to declare that you will use a flag from another file
	* Allows you to import new flags at runtime and reparses the original arguments to fill them once they are accessed.
	
	This hopefully gets around the issues described by vish in this thread:
	
	https://lists.launchpad.net/nova/msg00009.html

2010-08-10  jaypipes@gmail.com

	pylint fixes for /nova/test.py

2010-08-10  jaypipes@gmail.com

	Fixes pylint issues in /nova/server.py

2010-08-09  Eric Day <eday@oddments.org>

	This branch builds off of Todd and Michael's API branches to rework the Rackspace API endpoint and WSGI layers.

2010-08-09  Eric Day <eday@oddments.org>

	More pylint/pep8 cleanup, this time in bin/* files.

2010-08-07  Chris Behrens <cbehrens@codestud.com>

	Change nova/virt/images.py's _fetch_local_image to accept 4 args, since fetch() tries to call it with that many.

2010-08-06  Eric Day <eday@oddments.org>

	Some pylink and pep8 cleanups. Added a pylintrc file.

2010-08-06  Vishvananda Ishaya <vishvananda@gmail.com>

	Make network its own worker! This separates the network logic from the api server, allowing us to have multiple network controllers. There a lot of stuff in networking that is ugly and should be modified with the datamodel changes. I've attempted not to mess with those things too much to keep the changeset small(ha!).

2010-08-06  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixed instance model associations to host (node) and added association to ip.

2010-08-06  Devin Carlen <devin.carlen@gmail.com>

	Fixed write authorization for public images

2010-08-06  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes a bug where if a user was removed from a group after he had a role, he could not be re-added.

2010-08-05  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes various concurrency issues in volume worker.

2010-08-04  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes the curl to pass in the project properly

2010-08-04  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds flag for libvirt type (hvm, qemu, etc)

2010-08-04  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix deprecation warning in AuthManager. __new__ isn't allowed to take args.

2010-08-03  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes boto imports to support both beta and older versions of boto.

2010-08-02  Devin Carlen <devin.carlen@gmail.com>

	Added project as parameter to admin client x509 zip file download.

2010-07-30  Vishvananda Ishaya <vishvananda@gmail.com>

	Make nodaemon twistd processes log to stdout.

2010-07-30  Vishvananda Ishaya <vishvananda@gmail.com>

	boto.s3 no longer imports connection, so we need to explicitly import it.

2010-07-29  Monty Taylor <mordred@inaugust.com>

	Fixed pep8 in run_test.py.

2010-07-29  Ewan Mellor <ewan.mellor@citrix.com>

	Fixed assertion "Someone released me too many times: too many tokens!"

2010-07-29  Monty Taylor <mordred@inaugust.com>

	Added ChangeLog generation

2010-07-29  Devin Carlen <devin.carlen@gmail.com>

	Implemented admin api for rbac

2010-07-29  Ewan Mellor <ewan.mellor@citrix.com>

	Move the reading of API parameters above the call to _get_image, so that
	they have a chance to take effect.

2010-07-29  Ewan Mellor <ewan.mellor@citrix.com>

	Adds initial support for XenAPI (not yet finished)

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Allow driver specification in AuthManager creation.

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Use default kernel and ramdisk properly by default.

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds optional user param to the get projects command.

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Ensures default redis keys are lowercase like they were in prior versions of the code.

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Pass in environment to dnsmasq properly

2010-07-28  Monty Taylor <mordred@inaugust.com>

	Releaed 0.9.0, now on 0.9.1

2010-07-28  Todd Willey <todd@ansolabs.com>

	Removes logging when associating a model to something that isn't a model class.

2010-07-28  Todd Willey <todd@ansolabs.com>

	Create a model for storing session tokens.

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixed a typo from the the refactor of auth code

2010-07-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes ldap flags work again.

2010-07-28  Monty Taylor <mordred@inaugust.com>

	Got the tree set for debian packaging.

2010-07-28  Soren Hansen <soren.hansen@rackspace.com>

	Add sdist make target to build the MANIFEST.in file.

2010-07-28  Soren Hansen <soren.hansen@rackspace.com>

	Removes debian dir from main tree. We'll add it back in in a different branch.

2010-07-27  Soren Hansen <soren.hansen@rackspace.com>

	Bump version to 0.9.0.

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Makes the compute and volume daemon workers use a common base class called Service. Adds a NetworkService in preparation for splitting out networking code.  General cleanup and standardizarion of naming.

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes Bug lp:610611: deleted project vlans are deleted from the datastore before they are reused.

2010-07-27  Soren Hansen <soren.hansen@rackspace.com>

	Make "make test" detect whether to use virtualenv or not, thus making virtualenv optional.

2010-07-27  Soren Hansen <soren.hansen@rackspace.com>

	Makes the objectstore require authorization, checks it properly, and makes nova-compute provide it when fetching images.

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	fixes buildpackage failing with dh_install: missing files

2010-07-27  Paul Voccio <paul@openstack.org>

	resolving conflict w/ merge, cleaning up virtenv setups

2010-07-27  jaypipes@gmail.com

	Fixes bug#610140. Thanks to Vish and Muharem for the patch

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	A few minor fixes to the virtualenv installer that were breaking on ubuntu.

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Refactor of auth code
	
	projects are not created or destroyed automatically
	users and projects have an id that may not always == name
	users.py was renamed to manager.py
	manager singleton was changed from UserManager.instance() to AuthManager()
	the ldap backend was split into ldapdriver.py own file to support other backends
	lots of docstrings added
	ugly import fixed
	vpn ip and port returns none if vpn isn't allocated
	get_credentials returns exception if vpn isn't allocated
	flag for using vpns
	flag for auth_driver
	added exception for missing auth_driver

2010-07-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Ensure consistent use of filename for dhcp bridge flag file.

2010-07-26  andy <code@term.ie>

	Adds support scripts for installing deps into a virtualenv.

2010-07-26  andy <code@term.ie>

	Adds support scripts for installing deps into a virtualenv.

2010-07-26  Monty Taylor <mordred@inaugust.com>

	Updated doc layout to the Sphinx two-dir layout.

2010-07-26  Ewan Mellor <ewan.mellor@citrix.com>

	Replace hardcoded "nova" with FLAGS.control_exchange.

2010-07-26  Ewan Mellor <ewan.mellor@citrix.com>

	Fix references to image_object. This caused an internal error when using
	euca-deregister.

2010-07-26  Ewan Mellor <ewan.mellor@citrix.com>

	Set durable=False on TopicPublisher

2010-07-25  Ewan Mellor <ewan.mellor@citrix.com>

	Added missing import

2010-07-25  Vishvananda Ishaya <vishvananda@gmail.com>

	Changes nova-volume to use twisted.

2010-07-25  jaypipes@gmail.com

	Fixes up Bucket to throw proper NotFound and NotEmpty exceptions
	in constructor and delete() method, and fixes up objectstore_unittest
	to properly use assertRaises() to check for proper exceptions and
	remove the assert_ calls.

2010-07-25  Vishvananda Ishaya <vishvananda@gmail.com>

	Adds missing yield statement that was causing partitioning to intermittently fail.

2010-07-25  Monty Taylor <mordred@inaugust.com>

	Updated the README file

2010-07-23  Justin Santa Barbara <justin@fathomdb.com>

	Fixed bug 608505 - was freeing the wrong address (should have freed 'secondaddress', was freeing 'address')

2010-07-23  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes problem with describe-addresses returning all public ips instead of the ones for just the user's project

2010-07-23  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix for extra spaces in export statements in scripts relating to x509 certs

2010-07-21  Justin Santa Barbara <justin@fathomdb.com>

	Fix bug 607501.  Raise 403, not exception if Authorization header not passed. Also added missing call to request.finish() & Python exception-handling style tweak

2010-07-21  jaypipes@gmail.com

	update the logic for calculating network sizes

2010-07-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Locally administered mac addresses have the second least significant bit of the most significant byte set. If this byte is set then udev on ubuntu doesn't set persistent net rules.
	
	This patch changes the generate_mac to generate a locally administered mac address.

2010-07-21  Vishvananda Ishaya <vishvananda@gmail.com>

	Convert processpool to a singleton, and switch node.py calls to use it. (Replaces passing a processpool object around all the time.)

2010-07-19  Vishvananda Ishaya <vishvananda@gmail.com>

	Fixes to dhcp lease code to use a flagfile

2010-07-19  Jay Pipes <jaypipes@gmail.com>

	Redirect STDERR to output to an errlog file when running run_tests.py.
	
	Adds a flag option for specifying the output file and adds a bzr ignore rule to disregard the generated logfile.

2010-07-19  Joshua McKenty <jmckenty@gmail.com>

	Send message ack in rpc.call and make queues durable.

2010-07-19  Ewan Mellor <ewan.mellor@citrix.com>

	Fixed name change caused by remove-vendor merge.

2010-07-18  Soren Hansen <soren.hansen@rackspace.com>

	Replace tornado objectstore with twisted web.

2010-07-16  Todd Willey <todd@ansolabs.com>

	Minor post-merge fixes

2010-07-16  Justin Santa Barbara <justin@fathomdb.com>

	Fixed _redis_name and _redis_key

2010-07-16  Monty Taylor <mordred@inaugust.com>

	Add build_sphinx support.

2010-07-16  Soren Hansen <soren.hansen@rackspace.com>

	Merge lp:~anotherjesse/nova/remove-vendor

2010-07-16  Soren Hansen <soren.hansen@rackspace.com>

	Merge lp:~vishvananda/nova/remove-print

2010-07-15  Soren Hansen <soren.hansen@rackspace.com>

	This branch fixes some unfortunate interaction between Nova and boto.

2010-07-15  Soren Hansen <soren.hansen@rackspace.com>

	Merge with -core's diverged trunk.

2010-07-15  Todd Willey <todd@ansolabs.com>

	remove vendor

2010-07-15  Todd Willey <todd@ansolabs.com>

	update copyrights

2010-07-14  Joshua McKenty <jmckenty@gmail.com>

	Merge branch 'master' of github.com:angst/cc

2010-07-14  Joshua McKenty <jmckenty@gmail.com>

	Volume_ID identifier needed a return in the property. Also looking for race conditions in the destructor.

2010-07-15  Todd Willey <todd@ansolabs.com>

	add logging import to datastore

2010-07-15  Todd Willey <todd@ansolabs.com>

	fix merge errors

2010-06-29  Vishvananda Ishaya <vishvananda@gmail.com>

	removed all references to keeper

2010-06-29  Vishvananda Ishaya <vishvananda@gmail.com>

	reformatting

2010-06-29  Vishvananda Ishaya <vishvananda@gmail.com>

	Vpn ips and ports use redis

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge remote branch 'angst/apply_api' into diekeeper

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	formatting fixes and refactoring from code review

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	reformatting to fit within 80 characters

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	add object class violation exception to fakeldap

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	remove spaces from default cert

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	remove silly default from generate cert

2010-06-28  Vishvananda Ishaya <vishvananda@gmail.com>

	fix of fakeldap imports and exceptions

2010-06-27  Vishvananda Ishaya <vishvananda@gmail.com>

	More Comments, cleanup, and reformatting

2010-06-27  Vishvananda Ishaya <vishvananda@gmail.com>

	users.py cleanup for exception handling and typo

2010-06-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Make fakeldap use redis

2010-06-27  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge branch 'fixrbac' into fakeldap

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Create Volume should only take an integer between 0 and 1000

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Set forward delay to zero (partial fix to bug #518)

2010-06-23  Vishvananda Ishaya <vishvananda@gmail.com>

	Removed trailing whitespace from header

2010-06-23  Devin Carlen <devin.carlen@gmail.com>

	added nova-instancemonitor debian config

2010-06-23  Devin Carlen <devin.carlen@gmail.com>

	Updated licenses

2010-06-23  Devin Carlen <devin.carlen@gmail.com>

	Added flags to smoketests. General cleanup

2010-06-24  Devin Carlen <devin.carlen@gmail.com>

	Tweaks to get instancemonitor running

2010-06-24  andy <code@term.ie>

	Initial commit of nodemonitor
	
	Conflicts:
	
	bin/nova-instancemonitor
	nova/compute/monitor.py

2010-06-24  andy <code@term.ie>

	Create DescribeImageAttribute api method
	
	Conflicts:
	
	nova/endpoint/cloud.py

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	A few missing files from the twisted patch

2010-06-24  root <vishvananda@gmail.com>

	release 0.2.2-6

2010-06-24  andy <code@term.ie>

	disk.py needed input for key injection to work
	
	Conflicts:
	
	nova/compute/node.py

2010-06-24  root <vishvananda@gmail.com>

	release 2.2-5

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	message checking callbacks only need to run 10 times a second

2010-06-24  root <vishvananda@gmail.com>

	release 2.2-4

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge of fix to stop twisted threads from interuppting system calls
	http://twistedmatrix.com/trac/changeset/28447

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	trackback formatting isn't logging correctly

2010-06-24  andy <code@term.ie>

	documentation updates
	
	Conflicts:
	
	README

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix missing tab in nova-manage

2010-06-24  root <vishvananda@gmail.com>

	Release 2.2-3

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	use logger to print trace of unhandled exceptions

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	add exit status to nova-manage

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix fakeldap so it can use redis keeper

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix is_running failing because state was stored as a string

2010-06-24  andy <code@term.ie>

	more commands in nova-manage for projects and roles
	
	Conflicts:
	
	bin/nova-manage

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	More volume test fixes

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	typo in reboot instances

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix mount of drive for test image

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	don't need sudo anymore

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Cleaning up smoketests

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	boto uses instance_type not size

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix to volume smoketests

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix display of project name for admin in describe instances

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	make sure to deexpress before we remove the host since deexpress uses the host

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix error in disassociate address

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fixed reversed filtering logic

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	filter keypairs for vpn keys

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	allow multiple vpn connections with the same credentials

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Added admin command to restart networks

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	hide vpn instances unless you are an admin and allow run_instances to launch vpn image even if it is private

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	typo in my ping call

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	try to ping vpn instances

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	sensible defaults for instance types

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	add missing import to pipelib

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Give vpns the proper ip address

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix format addresses

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Release 0.2.2-2

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix more casing errors and make attachment set print

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	removed extraneous .volume_id

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	don't allow volumes to be attached to the same mountpoint

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix case for volume attributes

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix sectors off by one

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Don't use keeper for instances

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix default state to be 0 instead of pending

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Release 0.2.2

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Fix for mpi cpu reporting

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix detach volume

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix status code printing in cloud

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	add project ids to volumes

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	add back accidentally removed bridge name.
	str is reserved, so don't use it as a variable name

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	whitespace fixes and format instances set of object fixes

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Use instdir to iterate through instances

2010-06-24  andy <code@term.ie>

	fix bridge name
	
	Conflicts:
	
	nova/endpoint/cloud.py

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Adding basic validation of volume size on creation, plus tests for it.

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	finished gutting keeper from volume

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	First pass at validation unit tests. Haven't figured out class methods yet.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Removing keeper sludge.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Set volume status properly, first pass at validation decorators.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Adding missing default values and fixing bare Redis fetch for volume list.

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	one more handler typo

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	fix objectstore handler typo

2010-06-24  andy <code@term.ie>

	fix modify image attribute typo
	
	Conflicts:
	
	nova/endpoint/cloud.py

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	NetworkNode doesn't exist anymore

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Added back in missing gateway property on networks.

2010-06-24  andy <code@term.ie>

	Refactored Instance to get rid of _s bits, and fixed some bugs in state management.
	
	Conflicts:
	
	nova/compute/node.py

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Delete instance files on shutdown.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Flush redis db in setup and teardown of tests.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Cleaning up my accidental merge of the docs branch

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	change pipelib to work with projects

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Volumes support intermediate state. Don't have to cast to storage nodes for attach/detach anymore, just let node update redis with state.

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Adding nojekyll for directories

2010-06-24  Joshua McKenty <jmckenty@gmail.com>

	Fix for #437 (deleting attached volumes), plus some >9 blade_id fixes.

2010-06-24  andy <code@term.ie>

	fix instance iteration to use self.instdir.all instead of older iterators
	
	Conflicts:
	
	nova/endpoint/cloud.py

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	nasa ldap defaults

2010-06-24  andy <code@term.ie>

	sensible rbac defaults
	
	Conflicts:
	
	nova/endpoint/cloud.py

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Tests for rbac code

2010-06-24  andy <code@term.ie>

	Patch to allow rbac
	
	Conflicts:
	
	nova/auth/users.py

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Adding mpi data

2010-06-24  Vishvananda Ishaya <vishvananda@gmail.com>

	Adding cloudpipe and vpn data back in to network.py

2010-06-24  Jesse Andrews <anotherjesse@gmail.com>

	how we build our debs

2010-06-24  Jesse Andrews <anotherjesse@gmail.com>

	Revert "fix a bug with AOE number generation"
	
	This reverts commit 7e8b5bcbad634cd4eabd0387d70beb25115bb680.

2010-06-24  andy <code@term.ie>

	re-added cloudpipe
	
	Conflicts:
	
	bin/nova-manage
	nova/auth/users.py
	nova/compute/network.py

2010-06-24  Jesse Andrews <anotherjesse@gmail.com>

	devin's smoketests

2010-06-24  Jesse Andrews <anotherjesse@gmail.com>

	tools to clean vlans and run our old install script

2010-06-24  Jesse Andrews <anotherjesse@gmail.com>

	fix a bug with AOE number generation

2010-06-23  Devin Carlen <devin.carlen@gmail.com>

	Initial commit of nodemonitor

2010-06-22  Devin Carlen <devin.carlen@gmail.com>

	Create DescribeImageAttribute api method

2010-06-22  Devin Carlen <devin.carlen@gmail.com>

	Create DescribeImageAttribute api method

2010-06-20  Jesse Andrews <anotherjesse@gmail.com>

	update spacing

2010-06-20  Jesse Andrews <anotherjesse@gmail.com>

	implement image serving in objectstore so nginx isn't required in development
	
	reviewed by yosh

2010-06-20  Jesse Andrews <anotherjesse@gmail.com>

	update twitter username

2010-06-20  Todd Willey <todd@ansolabs.com>

	make a "Running" topic instead of having it flow under "Configuration".

2010-06-20  Todd Willey <todd@ansolabs.com>

	Make nginx config be in a code block.

2010-06-20  Todd Willey <todd@ansolabs.com>

	More doc updates: nginx & pycurl.

2010-06-20  Todd Willey <todd@ansolabs.com>

	Add a README, because GitHub loves them.  Update the getting started docs.

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge branch 'loop' into combined

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge branch 'deprecation' into combined

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge branch '4001' into combined

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge branch 'gateway' into combined

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	fix cloud instances method

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Various cloud fixes

2010-06-11  Vishvananda Ishaya <vishvananda@gmail.com>

	Merge remote branch 'nova/master'

2010-06-11  andy <code@term.ie>

	make get_my_ip return 127.0.0.1 for testing

2010-06-11  andy <code@term.ie>

	Adds a Twisted implementation of a process pool
	
	Meant for use instead of utils.execute()

2010-06-10  andy <code@term.ie>

	whitespace fixes for nova/utils.py

2010-05-30  Jesse Andrews <anotherjesse@gmail.com>

	Merged Vish's work on adding projects to nova

2010-05-30  Jesse Andrews <anotherjesse@gmail.com>

	missed the gitignore

2010-05-27  Jesse Andrews <anotherjesse@gmail.com>

	initial commit

